searchData={"items":[{"type":"module","title":"MishkaDeveloperTools","doc":"# Mishka Elixir Developer Tools\n\nWe tried to deliver a series of our client's [**CMS**](https://github.com/mishka-group/mishka-cms) built on [**Elixir**](https://elixir-lang.org/) at the start of the [**Mishka Group**](https://github.com/mishka-group) project, but we recently archived this open-source project and have yet to make plans to rework and expand it. This system was created using [**Phoenix**](https://www.phoenixframework.org/) and [**Phoenix LiveView**](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html). After a long period, a series of macros and functional modules emerged from this project and our other projects, which we are gradually publishing in this library.\n\n> **NOTICE**: Do not use the master branch; this library is under heavy development. Expect version `0.1.7`, and for using the new features, please wait until a new release is out.\n\n---\n\n- ### [GuardedStruct](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/guarded-struct.md)\n\n  > The creation of this macro will allow you to build `Structs` that provide you with a number of important options, including the following:\n  >\n  > 1. Validation\n  > 2. Sanitizing\n  > 3. Constructor\n  > 4. It provides the capacity to operate in a nested style simultaneously.\n\n- ### [PermissionAccess](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/permission-access.md)\n\n> Consider the scenario in which you are responsible for maintaining each user's access level in the database related to users.\n> **It is unix like way**.\n\n---\n\n> **Mishka developer tools** provides some macros and modules to make creating your elixir application as easy as possible","ref":"MishkaDeveloperTools.html"},{"type":"module","title":"Installation - MishkaDeveloperTools","doc":"The package can be installed by adding `mishka_developer_tools` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mishka_developer_tools, \"~> 0.1.7\"}\n  ]\nend\n```\n\nThe docs can be found at [https://hexdocs.pm/mishka_developer_tools](https://hexdocs.pm/mishka_developer_tools).\n\n[![Run in Livebook](https://livebook.dev/badge/v1/pink.svg)](https://livebook.dev/run?url=https%3A%2F%2Fgithub.com%2Fmishka-group%2Fmishka_developer_tools%2Fblob%2Fmaster%2Fguidance%2Fguarded-struct.livemd)\n\n---\n\n# Donate\n\nIf the project was useful for you, the only way you can donate to me is the following ways\n\n| **BTC**                                                                                                                            | **ETH**                                                                                                                            | **DOGE**                                                                                                                           | **TRX**                                                                                                                            |\n| ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- |\n|   |   |   |   |\n\n \n   Donate addresses \n\n**BTC**:‌\n\n```\nbc1q24pmrpn8v9dddgpg3vw9nld6hl9n5dkw5zkf2c\n```\n\n**ETH**:\n\n```\n0xD99feB9db83245dE8B9D23052aa8e62feedE764D\n```\n\n**DOGE**:\n\n```\nDGGT5PfoQsbz3H77sdJ1msfqzfV63Q3nyH\n```\n\n**TRX**:\n\n```\nTBamHas3wAxSEvtBcWKuT3zphckZo88puz\n```","ref":"MishkaDeveloperTools.html#module-installation"},{"type":"module","title":"MishkaDeveloperTools.Helper.Crypto","doc":"In reality, this module serves as a support for other libraries in addition\nto Erlang's built-in functions for encryption, hashing, and other topics that are associated\nwith the language.\n\nIt should be brought to your attention that certain functions necessitate the addition of their\ndependencies to the primary project. Consequently, prior to making use of these functionalities,\nestablish the appropriate dependence within the project in accordance with your requirements.\n\nThese functions are custom or wrappers, Copy from:\n\n- https://hexdocs.pm/plug_crypto/2.0.0/Plug.Crypto.html\n- https://hexdocs.pm/phoenix/Phoenix.Token.html\n- https://github.com/dashbitco/nimble_totp/blob/master/lib/nimble_totp.ex\n- https://dashbit.co/blog/introducing-nimble-totp\n- https://hex.pm/packages/bcrypt_elixir\n- https://hex.pm/packages/pbkdf2_elixir\n- https://password-hashing.net/\n- https://hex.pm/packages/argon2_elixir\n- https://github.com/malach-it/boruta_auth\n- https://github.com/joken-elixir/joken\n- https://hexdocs.pm/phoenix/mix_phx_gen_auth.html\n- https://hexdocs.pm/phoenix/Mix.Tasks.Phx.Gen.Secret.html","ref":"MishkaDeveloperTools.Helper.Crypto.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.base32_valid_otp?/2","doc":"For information See `valid_otp?/3` and `valid_otp?/2`","ref":"MishkaDeveloperTools.Helper.Crypto.html#base32_valid_otp?/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.base32_valid_otp?/3","doc":"For information See `valid_otp?/3` and `valid_otp?/2`","ref":"MishkaDeveloperTools.Helper.Crypto.html#base32_valid_otp?/3"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2"},{"type":"function","title":"Bcrypt - MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"- `bcrypt_elixir`: https://hex.pm/packages/bcrypt_elixir\n- `LICENSE`: https://github.com/riverrun/comeonin/blob/master/LICENSE\n\n> #### Use cases information {: .warning}\n>\n> Make sure you have a `C compiler` installed. See the Comeonin wiki for details.\n> Wiki link: https://github.com/riverrun/comeonin/wiki/Requirements\n\nBcrypt is a key derivation function for passwords designed by Niels\nProvos and David Mazières. Bcrypt is an adaptive function, which means\nthat it can be configured to remain slow and resistant to brute-force\nattacks even as computational power increases.\n\nBcrypt has no known vulnerabilities and has been widely tested for over 15 years.\nHowever, as it has a low memory use, it is susceptible to GPU cracking attacks.\n\n---\n\nYou are required to make use of this function in order to generate an irreversible (hashed)\nduplicate of the user's password when you are storing your password.\n\nAdditionally, you should save it in the database together with other unique features\nof your unique program.","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2-bcrypt"},{"type":"function","title":"Exmple: - MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"```elixir\ncreate_hash_password(\"USER_HARD_PASSWORD\", :bcrypt)\n```\n\n---","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2-exmple"},{"type":"function","title":"Pbkdf2 - MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"- `pbkdf2` - pbkdf2_elixir https://hex.pm/packages/pbkdf2_elixir\n- `LICENSE`: https://github.com/riverrun/pbkdf2_elixir/blob/master/LICENSE.md\n\nPbkdf2 is a password-based key derivation function that uses a password, a variable-length\nsalt and an iteration count and applies a pseudorandom function to these to produce a key.\n\nPbkdf2 has no known vulnerabilities and has been widely tested for over 15 years.\nHowever, like Bcrypt, as it has a low memory use, it is susceptible to GPU cracking attacks.\n\nThe original implementation of Pbkdf2 used SHA-1 as the pseudorandom function,\nbut this version uses HMAC-SHA-512, the default, or HMAC-SHA-256.","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2-pbkdf2"},{"type":"function","title":"Exmple: - MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"```elixir\ncreate_hash_password(\"USER_HARD_PASSWORD\", :pbkdf2)\n```\n\n---","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2-exmple"},{"type":"function","title":"Argon2 - MishkaDeveloperTools.Helper.Crypto.create_hash_password/2","doc":"Argon2 is the winner of the Password Hashing Competition (PHC).\n\n- https://password-hashing.net/\n- `argon2`: argon2_elixir https://hex.pm/packages/argon2_elixir (recommended)\n- https://github.com/riverrun/argon2_elixir/blob/master/LICENSE.md\n\nArgon2 is a memory-hard password hashing function which can be used to hash passwords for credential\nstorage, key derivation, or other applications.\n\nBeing memory-hard means that it is not only computationally expensive, but it also uses a\nlot of memory (which can be configured). This means that it is much more difficult\nto attack Argon2 hashes using GPUs or dedicated hardware.\n\n> #### Use cases information {: .warning}\n>\n> Make sure you have a `C compiler` installed. See the Comeonin wiki for details.\n> Wiki link: https://github.com/riverrun/comeonin/wiki/Requirements\n\n#### Configuration\nThe following four parameters can be set in the config file (these can all be overridden using keyword options):\n\n- t_cost - time cost\n> the amount of computation, given in number of iterations\n>\n> 3 is the default\n\n- m_cost - memory usage\n\n> 16 is the default - this will produce a memory usage of 64 MiB (2 ^ 16 KiB)\n>\n> parallelism - number of parallel threads\n>\n> 4 is the default\n\n- argon2_type - argon2 variant to use\n\n> 0 (Argon2d), 1 (Argon2i) or 2 (Argon2id)\n>\n> 2 is the default (Argon2id)\n\n---\n\nFor verifing you can use like this:\n\n```elixir\nverify_password(hash, \"USER_HARD_PASSWORD\", :bcrypt)\n\nverify_password(hash, \"USER_HARD_PASSWORD\", :pbkdf2)\n\nverify_password(hash, \"USER_HARD_PASSWORD\", :argon2)\n```","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_hash_password/2-argon2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.create_otp/2","doc":"For information See `create_otp_link_and_secret/2`","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_otp/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.create_otp/3","doc":"For information See `create_otp_link/3`","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_otp/3"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.create_otp_link/3","doc":"Generates an OTP authentication URL with a given secret, issuer, and label.\n\n#### Parameters:\n\n- **secret (binary)**: The secret key used to generate the OTP,\nit should be `:crypto.strong_rand_bytes/1`.\n- **issuer (String)**: The name of the issuer.\nThis helps to identify which service the OTP is associated with.\n- **label (String)**: A label used to identify the specific account or user.\n\n#### Returns:\n\nIt returns a map containing:\n\n- `:secret` (string) - It should be `:crypto.strong_rand_bytes/1` output which is\nconverted to `base32`.\n- `:url` (String) - The complete OTP authentication URL.\n\n#### Example:\n```elixir\nsecret = :crypto.strong_rand_bytes(20)\ncreate_otp_link(secret, \"Mishka\", \"user_test\")\n```\n\n> #### Use cases information {: .info}\n>\n> You are able to generate a QR code from the URL that you have made and then provide\n> it to the user. The majority of devices are able to scan it and utilize it as a\n> two-factor authentication one-time password with ease.\n\n- **More info: https://dashbit.co/blog/introducing-nimble-totp**","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_otp_link/3"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.create_otp_link_and_secret/2","doc":"Generates an OTP authentication URL with a given issuer, and label.\n\n#### Parameters:\n\n- **issuer (String)**: The name of the issuer.\nThis helps to identify which service the OTP is associated with.\n- **label (String)**: A label used to identify the specific account or user.\n\n#### Returns:\n\nIt returns a map containing:\n\n- `:secret` (string) - It should be `:crypto.strong_rand_bytes/1` output which is\nconverted to `base32`.\n- `:url` (String) - The complete OTP authentication URL.\n\n#### Example:\n```elixir\ncreate_otp_link_and_secret(\"Mishka\", \"user_test\")\n```\n\n> #### Use cases information {: .info}\n>\n> You are able to generate a QR code from the URL that you have made and then provide\n> it to the user. The majority of devices are able to scan it and utilize it as a\n> two-factor authentication one-time password with ease.\n\n- **More info: https://dashbit.co/blog/introducing-nimble-totp**","ref":"MishkaDeveloperTools.Helper.Crypto.html#create_otp_link_and_secret/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.decrypt/4","doc":"Decrypts the original data from the token and verifies its integrity.\nIts usage is identical to `verify/4` but for encrypted tokens.\n\n- Copy from: https://github.com/phoenixframework/phoenix/blob/v1.7.12/lib/phoenix/token.ex","ref":"MishkaDeveloperTools.Helper.Crypto.html#decrypt/4"},{"type":"function","title":"Options - MishkaDeveloperTools.Helper.Crypto.decrypt/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 1000\n* `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 32\n* `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to `:sha256`\n* `:max_age` - verifies the token only if it has been generated\n  \"max age\" ago in seconds. Defaults to the max age signed in the\n  token by `encrypt/4`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#decrypt/4-options"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.encrypt/4","doc":"Encodes, encrypts, and signs data into a token you can send to\nclients. Its usage is identical to that of `sign/4`, but the data\nis extracted using `decrypt/4`, rather than `verify/4`.\n\n  - Copy from: https://github.com/phoenixframework/phoenix/blob/v1.7.12/lib/phoenix/token.ex","ref":"MishkaDeveloperTools.Helper.Crypto.html#encrypt/4"},{"type":"function","title":"Options - MishkaDeveloperTools.Helper.Crypto.encrypt/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 1000\n* `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 32\n* `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to `:sha256`\n* `:signed_at` - set the timestamp of the token in seconds.\n  Defaults to `System.system_time(:second)`\n* `:max_age` - the default maximum age of the token. Defaults to\n  86400 seconds (1 day) and it may be overridden on `decrypt/4`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#encrypt/4-options"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.no_user_verify_password/2","doc":"","ref":"MishkaDeveloperTools.Helper.Crypto.html#no_user_verify_password/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.secret/1","doc":"Generate a binary composed of random bytes.\n\nThe number of bytes is defined by the `size` argument. Default is `20` per the\n[HOTP RFC](https://tools.ietf.org/html/rfc4226#section-4).\n\n**based on: https://github.com/dashbitco/nimble_totp/blob/master/lib/nimble_totp.ex**","ref":"MishkaDeveloperTools.Helper.Crypto.html#secret/1"},{"type":"function","title":"Examples - MishkaDeveloperTools.Helper.Crypto.secret/1","doc":"```elixir\nalias MishkaDeveloperTools.Helper.Crypto\n\nCrypto.secret()\n#=> <<178, 117, 46, 7, 172, 202, 108, 127, 186, 180, ...>>\n```","ref":"MishkaDeveloperTools.Helper.Crypto.html#secret/1-examples"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.sign/4","doc":"Encodes and signs data into a token you can send to clients.","ref":"MishkaDeveloperTools.Helper.Crypto.html#sign/4"},{"type":"function","title":"Options - MishkaDeveloperTools.Helper.Crypto.sign/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 1000\n* `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 32\n* `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to `:sha256`\n* `:signed_at` - set the timestamp of the token in seconds.\n  Defaults to `System.system_time(:second)`\n* `:max_age` - the default maximum age of the token. Defaults to\n  86400 seconds (1 day) and it may be overridden on `verify/4`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#sign/4-options"},{"type":"function","title":"Example: - MishkaDeveloperTools.Helper.Crypto.sign/4","doc":"```elixir\nkey_base = random_key_base()\nsign(key_base, \"user-secret\", {:elixir, :terms})\n```","ref":"MishkaDeveloperTools.Helper.Crypto.html#sign/4-example"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.simple_hash/1","doc":"For information See `simple_hash/2` and `simple_hash/3`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#simple_hash/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.simple_hash/3","doc":"This is a straightforward data hashing function that does not differentiate between\n**`symmetric`** and **`asymmetric`** functions according to their characteristics. Take, for instance,\nthe use of **`checksums`** or codes associated with `nonce`, `c_hash`, `at_hash`,\n`short-lived Access Token`, and other similar concepts.\n\n> #### Security issue {: .warning}\n>\n> It is not recommended to use this function for hashing passwords or JWTs.\n\n##### I inspired the initial code from this path:\n\n- https://github.com/malach-it/boruta_auth/blob/master/lib/boruta/oauth/schemas/client.ex#L173","ref":"MishkaDeveloperTools.Helper.Crypto.html#simple_hash/3"},{"type":"function","title":"Example: - MishkaDeveloperTools.Helper.Crypto.simple_hash/3","doc":"```elixir\nsimple_hash(\"Your text\", \"RS512\")\nsimple_hash(\"Your text\", \"RS512\", 32)\n\n# OR\nsimple_hash()\nsimple_hash(32)\n```\n\n> This function in all types of input and output is as follows\n\n```elixir\n{URL Encode64, Binary}\n```","ref":"MishkaDeveloperTools.Helper.Crypto.html#simple_hash/3-example"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.valid_otp?/2","doc":"Checks if a provided OTP is valid for the given secret.\n\n#### Parameters:\n\n- **secret (binary)**: The secret key used to generate the OTP,\nit should be `:crypto.strong_rand_bytes/1`.\n- `otp` (String): The OTP to verify, for example `\"581234\"`.\n\n#### Example:\n```elixir\nvalid_otp?(secret, \"581234\")\n\n# Or, you might put the time when the token was used for the last time to\n# prohibit the user from using it again.\n\nlast_used = System.os_time(:second)\nvalid_otp?(secret, \"581234\", last_used)\n```\n\n> #### Use cases information {: .tip}\n>\n> One thing to keep in mind is that you ought to have already kept the\n> secret of each user in a location such as a database.","ref":"MishkaDeveloperTools.Helper.Crypto.html#valid_otp?/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.valid_otp?/3","doc":"Checks if a provided OTP is valid for the given secret which is based32.\n\n#### Parameters:\n\n- **secret (binary)**: The secret key used to generate the OTP,\nit should be `:crypto.strong_rand_bytes/1`.\n- `otp` (String): The OTP to verify, for example `\"581234\"`.\n\n#### Example:\n```elixir\nvalid_otp?(secret, \"581234\", :base32)\n\n# Or, you might put the time when the token was used for the last time to\n# prohibit the user from using it again.\n\nlast_used = System.os_time(:second)\nvalid_otp?(secret, \"581234\", last_used, :base32)\n```\n\n> #### Use cases information {: .tip}\n>\n> One thing to keep in mind is that you ought to have already kept the\n> secret of each user in a location such as a database.","ref":"MishkaDeveloperTools.Helper.Crypto.html#valid_otp?/3"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.valid_otp?/4","doc":"For information See `valid_otp?/3` and `valid_otp?/2`","ref":"MishkaDeveloperTools.Helper.Crypto.html#valid_otp?/4"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.verify/4","doc":"Decodes the original data from the token and verifies its integrity.","ref":"MishkaDeveloperTools.Helper.Crypto.html#verify/4"},{"type":"function","title":"Examples - MishkaDeveloperTools.Helper.Crypto.verify/4","doc":"In this scenario we will create a token, sign it, then provide it to a client\napplication.\n\n```elixir\niex> user_id    = 99\niex> secret     = \"kjoy3o1zeidquwy1398juxzldjlksahdk3\"\niex> namespace  = \"user auth\"\niex> token      = sign(secret, namespace, user_id)\n```\n\nThe mechanism for passing the token to the client is typically through a\ncookie, a JSON response body, or HTTP header. For now, assume the client has\nreceived a token it can use to validate requests for protected resources.\n\nWhen the server receives a request, it can use `verify/4` to determine if it\nshould provide the requested resources to the client:\n\n```elixir\niex> verify(secret, namespace, token, max_age: 86400)\n{:ok, 99}\n```\n\nIn this example, we know the client sent a valid token because `verify/4`\nreturned a tuple of type `{:ok, user_id}`. The server can now proceed with\nthe request.\n\nHowever, if the client had sent an expired token, an invalid token, or `nil`,\n`verify/4` would have returned an error instead:\n\n```elixir\niex> verify(secret, namespace, expired, max_age: 86400)\n{:error, :expired}\n\niex> verify(secret, namespace, invalid, max_age: 86400)\n{:error, :invalid}\n\niex> verify(secret, namespace, nil, max_age: 86400)\n{:error, :missing}\n```","ref":"MishkaDeveloperTools.Helper.Crypto.html#verify/4-examples"},{"type":"function","title":"Options - MishkaDeveloperTools.Helper.Crypto.verify/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 1000\n* `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to 32\n* `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n  when generating the encryption and signing keys. Defaults to `:sha256`\n* `:max_age` - verifies the token only if it has been generated\n  \"max age\" ago in seconds. Defaults to the max age signed in the\n  token by `sign/4`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#verify/4-options"},{"type":"function","title":"MishkaDeveloperTools.Helper.Crypto.verify_password/3","doc":"For information See `create_hash_password/2`.","ref":"MishkaDeveloperTools.Helper.Crypto.html#verify_password/3"},{"type":"type","title":"MishkaDeveloperTools.Helper.Crypto.based32_url/0","doc":"","ref":"MishkaDeveloperTools.Helper.Crypto.html#t:based32_url/0"},{"type":"module","title":"MishkaDeveloperTools.Helper.Extra","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.app_started?/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#app_started?/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.erlang_fields/4","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#erlang_fields/4"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.erlang_guard/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#erlang_guard/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.erlang_result/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#erlang_result/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.get_unix_time/0","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#get_unix_time/0"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.get_unix_time_with_shift/2","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#get_unix_time_with_shift/2"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.randstring/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#randstring/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.timestamp/0","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#timestamp/0"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.validated_password?/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#validated_password?/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.Extra.validated_user?/1","doc":"","ref":"MishkaDeveloperTools.Helper.Extra.html#validated_user?/1"},{"type":"module","title":"MishkaDeveloperTools.Helper.UUID","doc":"**To make the UUID, this module is completely copied from the ecto project under the Apache License 2.0.**\n**For more information and more functions, please refer to the following path:**\n\n- https://github.com/elixir-ecto/ecto/blob/v3.11.2/lib/ecto/uuid.ex#L1\n- https://hexdocs.pm/ecto/Ecto.UUID.html\n\n> It should be noted that this file only supports uuid version 4.\n> To use other versions in hex, look for another library","ref":"MishkaDeveloperTools.Helper.UUID.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.UUID.bingenerate/0","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#bingenerate/0"},{"type":"function","title":"MishkaDeveloperTools.Helper.UUID.cast/1","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#cast/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.UUID.cast!/1","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#cast!/1"},{"type":"function","title":"MishkaDeveloperTools.Helper.UUID.generate/0","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#generate/0"},{"type":"type","title":"MishkaDeveloperTools.Helper.UUID.raw/0","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#t:raw/0"},{"type":"type","title":"MishkaDeveloperTools.Helper.UUID.t/0","doc":"","ref":"MishkaDeveloperTools.Helper.UUID.html#t:t/0"},{"type":"module","title":"MnesiaAssistant","doc":"`MnesiaAssistant` is a wrapper for the Mnesia (Top level Erlang runtime database, ETS) module.\nIts primary purpose is to facilitate the utilisation of this database in Elixir.\nAdditionally, it offers a number of features, such as the standardisation of\nthe output and routes, as well as various hooks and helpers in this particular domain.\n\nThe following is a list of the primary modules that you plan on using in your project:\n\n1. `MnesiaAssistant.Schema`\n2. `MnesiaAssistant.Table`\n3. `MnesiaAssistant.Query`\n4. `MnesiaAssistant.Transaction`\n5. `MnesiaAssistant.Information`\n6. `MnesiaAssistant.BackupAndRestore`","ref":"MnesiaAssistant.html"},{"type":"function","title":"MnesiaAssistant.change_config/2","doc":"The `:mnesia.change_config/2` function in Mnesia, the distributed database management\nsystem in Erlang/OTP, is used to dynamically change the configuration parameters\nof the Mnesia system while it is running.\n\nThis function allows you to adjust certain operational parameters of Mnesia\nwithout needing to stop and restart the database,\nmaking it particularly useful for tuning performance or behavior in live systems.\n\n* `config`: --> extra_db_nodes | dc_dump_limit\n* `value`: -->  [node()] | number()","ref":"MnesiaAssistant.html#change_config/2"},{"type":"function","title":"Example - MnesiaAssistant.change_config/2","doc":"```elixir\n  MnesiaAssistant.change_config(config, value)\n```","ref":"MnesiaAssistant.html#change_config/2-example"},{"type":"function","title":"MnesiaAssistant.eg/1","doc":"","ref":"MnesiaAssistant.html#eg/1"},{"type":"function","title":"MnesiaAssistant.er/1","doc":"","ref":"MnesiaAssistant.html#er/1"},{"type":"function","title":"MnesiaAssistant.erl_fields/4","doc":"","ref":"MnesiaAssistant.html#erl_fields/4"},{"type":"function","title":"MnesiaAssistant.info/0","doc":"","ref":"MnesiaAssistant.html#info/0"},{"type":"function","title":"MnesiaAssistant.info/1","doc":"","ref":"MnesiaAssistant.html#info/1"},{"type":"function","title":"MnesiaAssistant.report_event/1","doc":"When tracing a system of Mnesia applications it is useful to be able to\ninterleave Mnesia own events with `application-related` events that give\ninformation about the application context.\n\nWhenever the application begins a new and demanding Mnesia task,\nor if it enters a new interesting phase in its execution, it can be a good idea\nto use mnesia:report_event/1. Event can be any term and generates\na `{mnesia_user, Event}` event for any processes that subscribe\nto Mnesia system events. for more information read `subscribe/1` document.","ref":"MnesiaAssistant.html#report_event/1"},{"type":"function","title":"Example: - MnesiaAssistant.report_event/1","doc":"```elixir\nMnesiaAssistant.report_event(event)\n```","ref":"MnesiaAssistant.html#report_event/1-example"},{"type":"function","title":"MnesiaAssistant.schema/0","doc":"","ref":"MnesiaAssistant.html#schema/0"},{"type":"function","title":"MnesiaAssistant.schema/1","doc":"","ref":"MnesiaAssistant.html#schema/1"},{"type":"function","title":"MnesiaAssistant.set_debug_level/1","doc":"","ref":"MnesiaAssistant.html#set_debug_level/1"},{"type":"function","title":"MnesiaAssistant.set_dir/1","doc":"The `mnesia` database provides you with the capability to perform your storage\neither on the hard drive or on the RAM, or both at the same time, depending\non the software approach that you have chosen. In order to accomplish this goal,\nits path for storage on the disc (the position of storage) must be known.\nThis can be accomplished in a number of different ways.\n\nYou can begin the compilation process by using the configuration file of\nyour programme. In this technique, you will need to specify the directory\nfor the `:mnesia` (`:dir`) command. And then there is the second technique,\nwhich is the function of the same function and is carried out in the form of run time.","ref":"MnesiaAssistant.html#set_dir/1"},{"type":"function","title":"Example - MnesiaAssistant.set_dir/1","doc":"```elixir\n  MnesiaAssistant.set_dir(\"/tmp/db\") # --> Application.put_env(:mnesia, :dir, dir)\n```","ref":"MnesiaAssistant.html#set_dir/1-example"},{"type":"function","title":"MnesiaAssistant.start/0","doc":"In order to fulfil the requirements of the **Elixir** project,\nit is necessary for you to activate this database in\naddition to executing the `mnesia` function within the `mix.exs` file.\nBoth activation and information for determining whether or not it is\nactive are accomplished through the utilisation of these functions.\n\nTwo distinct variants of this function have been generated for your use.\nIt is important to note that the `start/0` function is a wrapper\nfrom Erlang, while the second function is responsible for activating\n`mnesia` in Elixir (`start/1` :: `:app`).\n\n> In order to activate programmes, we utilise the `start/1` command with\n> the input `:app`.","ref":"MnesiaAssistant.html#start/0"},{"type":"function","title":"Example - MnesiaAssistant.start/0","doc":"```elixir\n  MnesiaAssistant.start() # --> :mnesia.start()\n  # OR\n  MnesiaAssistant.start(:app) # --> Application.start(:mnesia)\n```","ref":"MnesiaAssistant.html#start/0-example"},{"type":"function","title":"MnesiaAssistant.start/1","doc":"Read `start/0` document.","ref":"MnesiaAssistant.html#start/1"},{"type":"function","title":"MnesiaAssistant.started?/0","doc":"This function determines whether or not the `mnesia` function is active.\nThe output of the `Application.started_applications()` function\nis what this function actually searches for.","ref":"MnesiaAssistant.html#started?/0"},{"type":"function","title":"Example - MnesiaAssistant.started?/0","doc":"```elixir\n  MnesiaAssistant.started?()\n```","ref":"MnesiaAssistant.html#started?/0-example"},{"type":"function","title":"MnesiaAssistant.stop/0","doc":"You have the ability to disable mnesia by using the function.\nIn the same way that the `start/0` function has two forms,\nthis function also has two forms. One of the forms is a wrapper\nfor the `mnesia` function itself, while the other form disables\nthe `mnesia` **Elixir** red applications that have been active.","ref":"MnesiaAssistant.html#stop/0"},{"type":"function","title":"Example - MnesiaAssistant.stop/0","doc":"```elixir\n  MnesiaAssistant.stop() # --> :mnesia.stop()\n  # OR\n  MnesiaAssistant.stop(:app) # --> Application.stop(:mnesia)\n```","ref":"MnesiaAssistant.html#stop/0-example"},{"type":"function","title":"MnesiaAssistant.stop/1","doc":"Read `stop/1` document.","ref":"MnesiaAssistant.html#stop/1"},{"type":"function","title":"MnesiaAssistant.subscribe/1","doc":"Using this function, you will be able to subscribe to Mnesia's activities\nand events, and you will receive notifications immediately after an\nevent takes place. For example, if you are using `GenServer` and you want\nto carry out a particular activity in real time based on a strategy, you can\nmake use of this method.","ref":"MnesiaAssistant.html#subscribe/1"},{"type":"function","title":"Example - MnesiaAssistant.subscribe/1","doc":"```elixir\n  MnesiaAssistant.subscribe({:table, Person})\n  # -> :mnesia.subscribe({:table, table})\n  MnesiaAssistant.subscribe({:table, Person, simple_detailed})\n  # -> :mnesia.subscribe({:table, table, simple_detailed})\n  MnesiaAssistant.subscribe(what)\n  # -> :mnesia.subscribe(what)\n  # What = system | activity | {table, table(), simple | detailed}\n```","ref":"MnesiaAssistant.html#subscribe/1-example"},{"type":"function","title":"MnesiaAssistant.tuple_to_map/3","doc":"","ref":"MnesiaAssistant.html#tuple_to_map/3"},{"type":"function","title":"MnesiaAssistant.tuple_to_map/4","doc":"","ref":"MnesiaAssistant.html#tuple_to_map/4"},{"type":"function","title":"MnesiaAssistant.unsubscribe/1","doc":"In order to terminate your subscription to mnesia, you can use the following function.\nFor more information read `subscribe/1`","ref":"MnesiaAssistant.html#unsubscribe/1"},{"type":"function","title":"Example - MnesiaAssistant.unsubscribe/1","doc":"```elixir\nMnesiaAssistant.unsubscribe({:table, Person})\n# -> :mnesia.unsubscribe({:table, table})\nMnesiaAssistant.unsubscribe({:table, Person, simple_detailed})\n# -> :mnesia.unsubscribe({:table, table, simple_detailed})\nMnesiaAssistant.unsubscribe(what)\n# -> :mnesia.unsubscribe(what)\n# What = system | activity | {table, table(), simple | detailed}\n```","ref":"MnesiaAssistant.html#unsubscribe/1-example"},{"type":"module","title":"MnesiaAssistant.BackupAndRestore","doc":"This module is where you will find the collection of functions that can\nassist you in obtaining a support version of `Mnesia` or in recovering the\nbackup that was stored in the system.\nAdditionally, it is possible to have a variety of inputs and consequently outputs.","ref":"MnesiaAssistant.BackupAndRestore.html"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.backup/1","doc":"With this function, you can get a support version of `mnesia`.\n\n> Activates a new checkpoint covering all Mnesia tables,\n> including the schema, with maximum degree of redundancy,\n> and performs a backup using `backup_checkpoint/2` and `backup_checkpoint/3`. The\n> default value of the backup callback module BackupMod is\n> obtained by `mnesia:system_info(backup_module)`.","ref":"MnesiaAssistant.BackupAndRestore.html#backup/1"},{"type":"function","title":"Example - MnesiaAssistant.BackupAndRestore.backup/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.backup(backup_path)\n  MnesiaAssistant.BackupAndRestore.backup(backup_path, module)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#backup/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.backup/2","doc":"Read `backup/1` document.","ref":"MnesiaAssistant.BackupAndRestore.html#backup/2"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.backup_checkpoint/2","doc":"Read `backup_checkpoint/3` document.","ref":"MnesiaAssistant.BackupAndRestore.html#backup_checkpoint/2"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.backup_checkpoint/3","doc":"The `:mnesia.backup_checkpoint/2` function is used in Mnesia to create a\nbackup of the database at a specific checkpoint.\n\nThis function allows you to specify a checkpoint name, and `Mnesia`\nwill generate a backup that includes all changes up to that point.\n\nThis is particularly useful for creating consistent backups of the\ndatabase state at known good points, facilitating easier recovery in\ncase of data corruption or loss.\n\n> The tables are backed up to external media using backup module BackupMod.\nTables with the local contents property are backed up as they exist on\nthe current node. BackupMod is the default backup callback module obtained\nby `mnesia:system_info(backup_module)`. For information about the exact\ncallback interface (the mnesia_backup behavior), see the User's Guide.\n\n```erlang\n  backup_checkpoint(Name, Dest) -> result()\n  backup_checkpoint(Name, Dest, Mod) -> result()\n```","ref":"MnesiaAssistant.BackupAndRestore.html#backup_checkpoint/3"},{"type":"function","title":"Example - MnesiaAssistant.BackupAndRestore.backup_checkpoint/3","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.backup_checkpoint(name, dest, mod)\n  MnesiaAssistant.BackupAndRestore.backup_checkpoint(name, dest)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#backup_checkpoint/3-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.dump_log/0","doc":"Performs a user-initiated dump of the local log file.\nThis is usually not necessary, as Mnesia by default manages this automatically","ref":"MnesiaAssistant.BackupAndRestore.html#dump_log/0"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.dump_log/0","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.dump_log() # --> :mnesia.dump_log()\n```","ref":"MnesiaAssistant.BackupAndRestore.html#dump_log/0-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.dump_tables/1","doc":"Dumps a set of `ram_copies` tables to disc. The next time the system is started,\nthese tables are initiated with the data found in the files that are the\nresult of this dump. None of the tables can have `disc-resident` replicas.","ref":"MnesiaAssistant.BackupAndRestore.html#dump_tables/1"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.dump_tables/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.dump_tables(tables) # --> :mnesia.dump_tables(tables)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#dump_tables/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.dump_to_textfile/1","doc":"The `:mnesia.dump_to_textfile/1` function in `Mnesia` is used to dump the contents\nof one or more Mnesia tables to a text file.\nEach record is written to the file as an Erlang term, one term per line.\nThis can be useful for backing up data or exporting it for\nanalysis or use in other systems.\n\n> Dumps all local tables of a Mnesia system into a text file,\n> which can be edited (by a normal text editor) and then be reloaded\n> with `mnesia:load_textfile/1`.\n> Only use this function for educational purposes.\n> Use other functions to deal with real backups.","ref":"MnesiaAssistant.BackupAndRestore.html#dump_to_textfile/1"},{"type":"function","title":"Example - MnesiaAssistant.BackupAndRestore.dump_to_textfile/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.dump_to_textfile(\"/path/to/person.txt\")\n```","ref":"MnesiaAssistant.BackupAndRestore.html#dump_to_textfile/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.install_fallback/1","doc":"Installs a backup as fallback. The fallback is used to restore the database\nat the next startup. Installation of fallbacks requires Erlang to be operational\non all the involved nodes, but it does not matter if Mnesia is running or not.\nThe installation of the fallback fails if the local node is\nnot one of the `disc-resident` nodes in the backup.","ref":"MnesiaAssistant.BackupAndRestore.html#install_fallback/1"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.install_fallback/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.install_fallback(source)\n  # --> :mnesia.install_fallback(source)\n  MnesiaAssistant.BackupAndRestore.install_fallback(source, module)\n  # --> :mnesia.install_fallback(source, module)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#install_fallback/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.install_fallback/2","doc":"Read `install_fallback/1` document.","ref":"MnesiaAssistant.BackupAndRestore.html#install_fallback/2"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.load_textfile/1","doc":"The `:mnesia.load_textfile/1` function in `Mnesia` is used to load data from a\ntext file into a Mnesia table. The text file should contain Erlang terms,\nwith one term per line, matching the structure of the records in the target table.","ref":"MnesiaAssistant.BackupAndRestore.html#load_textfile/1"},{"type":"function","title":"Example - MnesiaAssistant.BackupAndRestore.load_textfile/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.load_textfile(\"/path/to/person.txt\")\n```","ref":"MnesiaAssistant.BackupAndRestore.html#load_textfile/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.restore/2","doc":"With this function, tables can be restored online from a backup\nwithout restarting Mnesia. Opaque is forwarded to the backup module.\n`args` is a list of the following tuples:\n\n* `Op`: skip_tables | clear_tables | keep_tables | restore_tables\n* `Arg`: {module, module()} | {Op, [table()]} | {default_op, Op}\n\n---\n\n1. `{module,BackupMod}`. The backup module BackupMod is used to\naccess the backup media. If omitted, the default backup module is used.\n2. `{skip_tables, TabList}`, where TabList is a list of tables that is\nnot to be read from the backup.\n3. `{clear_tables, TabList}`, where TabList is a list of tables that\nis to be cleared before the records from the backup are inserted.\nThat is, all records in the tables are deleted before the tables are restored.\nSchema information about the tables is not cleared or read from the backup.\n4. `{keep_tables, TabList}`, where TabList is a list of tables that is not\nto be cleared before the records from the backup are inserted.\nThat is, the records in the backup are added to the records in the table.\nSchema information about the tables is not cleared or read from the backup.\n5. `{recreate_tables, TabList}`, where TabList is a list of tables that is\nto be recreated before the records from the backup are inserted.\nThe tables are first deleted and then created with the schema information\nfrom the backup. All the nodes in the backup need to be operational.\n6. `{default_op, Operation}`, where Operation is either of the operations `skip_tables`,\n`clear_tables`, `keep_tables`, or `recreate_tables`.\nThe default operation specifies which operation that is to be used on\ntables from the backup that is not specified in any of the mentioned lists.\nIf omitted, operation clear_tables is used.\n\n> The affected tables are `write-locked` during the restoration.\n> However, regardless of the lock conflicts caused by this,\n> the applications can continue to do their work while the restoration\n> is being performed. The restoration is performed as one single transaction.\n\n> If the database is huge, it it not always possible to restore it online.\n> In such cases, restore the old database by installing a fallback and then restart.","ref":"MnesiaAssistant.BackupAndRestore.html#restore/2"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.restore/2","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.restore(\n    \"/tmp/mnesia_backup\", [{:skip_tables, [Person]}]\n  )\n```","ref":"MnesiaAssistant.BackupAndRestore.html#restore/2-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.set_master_nodes/1","doc":"Sets master nodes for `mnesia`.\n\n> For each table Mnesia determines its replica nodes (TabNodes) and\n> starts `mnesia:set_master_nodes(Tab, TabMasterNodes)`.\n> where `TabMasterNodes` is the intersection of `MasterNodes` and `TabNodes`.\n> For semantics, see `mnesia:set_master_nodes/2`.","ref":"MnesiaAssistant.BackupAndRestore.html#set_master_nodes/1"},{"type":"function","title":"Example - MnesiaAssistant.BackupAndRestore.set_master_nodes/1","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.set_master_nodes([node()])\n```","ref":"MnesiaAssistant.BackupAndRestore.html#set_master_nodes/1-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.traverse_backup/4","doc":"Iterates over a backup, either to transform it into a new backup, or read it.\nThe arguments are explained briefly here. For details, see the User's Guide.\n\n* SourceMod and TargetMod are the names of the modules that actually\naccess the backup media.\n* Source and Target are opaque data used exclusively by modules SourceMod and\nTargetMod to initialize the backup media.\n* Acc is an initial accumulator value.\n* Fun(BackupItems, Acc) is applied to each item in the backup.\nThe Fun must return a tuple {BackupItems,NewAcc}, where BackupItems is a list of valid backup items, and NewAcc is a new accumulator value. The returned backup items are written in the target backup.\n* LastAcc is the last accumulator value. This is the last NewAcc value\nthat was returned by Fun.\n\n> The `:mnesia.traverse_backup/4` function in Mnesia is designed for traversing\n> and processing the contents of a `Mnesia` backup file.\n> This functionality is particularly useful when you need to inspect,\n> analyze, or selectively restore data from a backup.\n> The `traverse_backup` function allows you to specify callback functions\n> that will be called with the data from the backup, enabling you to\n> programmatically interact with the backup contents.\n\n```erlang\n  traverse_backup(Src :: term(), Dest :: term(), Fun, Acc) ->\n  traverse_backup(Src :: term(), SrcMod :: module(), Dest :: term(), DestMod :: module(), Fun, Acc)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#traverse_backup/4"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.traverse_backup/4","doc":"```elixir\n  initial_acc = []  # Initial value for the accumulator\n\n  MnesiaAssistant.BackupAndRestore.traverse_backup(\n    source,\n    dest,\n    &BackupTraversal.table_fun/2,\n    initial_acc\n  )\n  # OR\n  MnesiaAssistant.BackupAndRestore.traverse_backup(\n    source,\n    source_module,\n    dest,\n    dest_module\n    &BackupTraversal.table_fun/2,\n    initial_acc\n  )\n```","ref":"MnesiaAssistant.BackupAndRestore.html#traverse_backup/4-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.traverse_backup/6","doc":"Read `traverse_backup/4` document.","ref":"MnesiaAssistant.BackupAndRestore.html#traverse_backup/6"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.uninstall_fallback/0","doc":"Deinstalls a fallback before it has been used to restore the database.\nThis is normally a distributed operation that is either performed\non all nodes with disc resident schema, or none.\n\nUninstallation of fallbacks requires Erlang to be operational on all\ninvolved nodes, but it does not matter if Mnesia is running or not.\nWhich nodes that are considered as disc-resident nodes is determined\nfrom the schema information in the local fallback.\n\n```erlang\n Args = [{mnesia_dir, Dir :: string()}]\n {module, BackupMod}. For semantics, see mnesia:install_fallback/2.\n {scope, Scope}. For semantics, see mnesia:install_fallback/2.\n {mnesia_dir, AlternateDir}. For semantics, see mnesia:install_fallback/2.\n```","ref":"MnesiaAssistant.BackupAndRestore.html#uninstall_fallback/0"},{"type":"function","title":"Example: - MnesiaAssistant.BackupAndRestore.uninstall_fallback/0","doc":"```elixir\n  MnesiaAssistant.BackupAndRestore.uninstall_fallback()\n  # --> :mnesia.uninstall_fallback()\n  MnesiaAssistant.BackupAndRestore.uninstall_fallback(args)\n  # --> :mnesia.uninstall_fallback(args)\n```","ref":"MnesiaAssistant.BackupAndRestore.html#uninstall_fallback/0-example"},{"type":"function","title":"MnesiaAssistant.BackupAndRestore.uninstall_fallback/1","doc":"Read `uninstall_fallback/0` document.","ref":"MnesiaAssistant.BackupAndRestore.html#uninstall_fallback/1"},{"type":"module","title":"MnesiaAssistant.Error","doc":"","ref":"MnesiaAssistant.Error.html"},{"type":"function","title":"MnesiaAssistant.Error.error_description/1","doc":"","ref":"MnesiaAssistant.Error.html#error_description/1"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Error.error_description/1","doc":"All Mnesia transactions, including all the schema update functions, either return value `{atomic, Val}`\nor the tuple `{aborted, Reason}`. Reason can be either of the atoms in the following list.\nThe function `error_description/1` returns a descriptive string that describes the error.\n\n\n- `nested_transaction`. Nested transactions are not allowed in this context.\n- `badarg`. Bad or invalid argument, possibly bad type.\n- `no_transaction`. Operation not allowed outside transactions.\n- `combine_error`. Table options illegally combined.\n- `bad_index`. Index already exists, or was out of bounds.\n- `already_exists`. Schema option to be activated is already on.\n- `index_exists`. Some operations cannot be performed on tables with an index.\n- `no_exists`. Tried to perform operation on non-existing (not-alive) item.\n- `system_limit`. A system limit was exhausted.\n- `mnesia_down`. A transaction involves records on a remote node, which became unavailable\nbefore the transaction was completed. Records are no longer available elsewhere in the network.\n- `not_a_db_node`. A node was mentioned that does not exist in the schema.\n- `bad_type`. Bad type specified in argument.\n- `node_not_running`. Node is not running.\n- `truncated_binary_file`. Truncated binary in file.\n- `active`. Some delete operations require that all active records are removed.\n- `illegal`. Operation not supported on this record.\n\nError can be Reason, `{error, Reason}`, or `{aborted, Reason}`. Reason can be an atom or a\ntuple with Reason as an atom in the first field.\n\nThe following examples illustrate a function that returns an error, and the method to\nretrieve more detailed error information:\n\n- The function `mnesia:create_table(bar, [{attributes, 3.14}])` returns the tuple `{aborted,Reason}`, where\nReason is the tuple `{bad_type,bar,3.14000}`.\n\nThe function `mnesia:error_description(Reason)` returns the term `{\"Bad type on some provided arguments\",bar,3.14000}`,\nwhich is an error description suitable for display.\n\n- `error_description(Error :: term())`","ref":"MnesiaAssistant.Error.html#error_description/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Error.error_description/1","doc":"```elixir\n  MnesiaAssistant.Error.error_description(error)\n```","ref":"MnesiaAssistant.Error.html#error_description/1-example"},{"type":"function","title":"MnesiaAssistant.Error.error_description/2","doc":"","ref":"MnesiaAssistant.Error.html#error_description/2"},{"type":"function","title":"MnesiaAssistant.Error.try?/1","doc":"","ref":"MnesiaAssistant.Error.html#try?/1"},{"type":"function","title":"MnesiaAssistant.Error.try?/3","doc":"","ref":"MnesiaAssistant.Error.html#try?/3"},{"type":"module","title":"MnesiaAssistant.Information","doc":"This particular module is actually a set of functions in `Mnesia` that are designed\nto supply the user with the information that they require regarding the system.","ref":"MnesiaAssistant.Information.html"},{"type":"function","title":"MnesiaAssistant.Information.info/0","doc":"This function is actually a combination of two functions\nin mnesia(`:mnesia.info()`, `:mnesia.schema()`).","ref":"MnesiaAssistant.Information.html#info/0"},{"type":"function","title":"Example: - MnesiaAssistant.Information.info/0","doc":"```elixir\n  MnesiaAssistant.Information.info()\n  # OR\n  MnesiaAssistant.Information.info({:system, type})\n  # OR\n  MnesiaAssistant.Information.info(type)\n```\n\nAll types you can use:\n```\n  [\n    :all,\n    :access_module,\n    :auto_repair,\n    :backup_module,\n    :checkpoints,\n    :event_module,\n    :db_nodes,\n    :debug,\n    :directory,\n    :dump_log_load_regulation,\n    :dump_log_time_threshold,\n    :dump_log_update_in_place,\n    :dump_log_write_threshold,\n    :extra_db_nodes,\n    :fallback_activated,\n    :held_locks,\n    :is_running,\n    :local_tables,\n    :lock_queue,\n    :log_version,\n    :master_node_tables,\n    :protocol_version,\n    :running_db_nodes,\n    :schema_location,\n    :subscribers,\n    :tables,\n    :transactions,\n    :transaction_failures,\n    :transaction_commits,\n    :transaction_restarts,\n    :transaction_log_writes,\n    :use_dir,\n    :version,\n    :schema\n  ]\n```","ref":"MnesiaAssistant.Information.html#info/0-example"},{"type":"function","title":"MnesiaAssistant.Information.info/1","doc":"Read `info/0` document.","ref":"MnesiaAssistant.Information.html#info/1"},{"type":"function","title":"MnesiaAssistant.Information.set_debug_level/1","doc":"If the application detects a communication failure (in a potentially partitioned network)\nthat can have caused an inconsistent database, it can use the function\n`mnesia:set_master_nodes(Tab, MasterNodes)` to define from which nodes\neach table is to be loaded. At startup, the Mnesia normal table load algorithm is\nbypassed and the table is loaded from one of the master nodes defined for the table,\nregardless of when and if Mnesia terminated on other nodes. MasterNodes can only\ncontain nodes where the table has a replica. If the MasterNodes list is empty,\nthe master node recovery mechanism for the particular table is reset,\nand the normal load mechanism is used at the next restart.\n\n> The master node setting is always local. It can be changed regardless\n> if Mnesia is started or not.\n\nThe database can also become inconsistent if configuration\nparameter `max_wait_for_decision` is used or if `mnesia:force_load_table/1` is used.","ref":"MnesiaAssistant.Information.html#set_debug_level/1"},{"type":"function","title":"Example: - MnesiaAssistant.Information.set_debug_level/1","doc":"```elixir\n  MnesiaAssistant.Information.set_debug_level(level)\n```\n\nAll level you can use: `[:none, :verbose, :debug, :trace, false, true]`","ref":"MnesiaAssistant.Information.html#set_debug_level/1-example"},{"type":"function","title":"MnesiaAssistant.Information.sync_log/0","doc":"Ensures that the local transaction log file is synced to disk.\nOn a single node system, data written to disk tables since the\nlast dump can be lost if there is a power outage.","ref":"MnesiaAssistant.Information.html#sync_log/0"},{"type":"function","title":"Example: - MnesiaAssistant.Information.sync_log/0","doc":"```elixir\n  MnesiaAssistant.Information.sync_log()\n```","ref":"MnesiaAssistant.Information.html#sync_log/0-example"},{"type":"function","title":"MnesiaAssistant.Information.system_info/1","doc":"Read `info/0` document.","ref":"MnesiaAssistant.Information.html#system_info/1"},{"type":"module","title":"MnesiaAssistant.Pagination","doc":"","ref":"MnesiaAssistant.Pagination.html"},{"type":"function","title":"MnesiaAssistant.Pagination.infinite_scroll/3","doc":"","ref":"MnesiaAssistant.Pagination.html#infinite_scroll/3"},{"type":"function","title":"MnesiaAssistant.Pagination.infinite_scroll/5","doc":"","ref":"MnesiaAssistant.Pagination.html#infinite_scroll/5"},{"type":"function","title":"MnesiaAssistant.Pagination.infinite_scroll/6","doc":"","ref":"MnesiaAssistant.Pagination.html#infinite_scroll/6"},{"type":"function","title":"MnesiaAssistant.Pagination.numerical/4","doc":"","ref":"MnesiaAssistant.Pagination.html#numerical/4"},{"type":"function","title":"MnesiaAssistant.Pagination.numerical/6","doc":"","ref":"MnesiaAssistant.Pagination.html#numerical/6"},{"type":"module","title":"MnesiaAssistant.Query","doc":"**Querying** is one of the most significant aspects of working with the **database**;\nfor this reason, you can access the aggregation functions of `Mnesia`\nin this section of the database.","ref":"MnesiaAssistant.Query.html"},{"type":"function","title":"MnesiaAssistant.Query.delete/2","doc":"Read `delete/3` document.","ref":"MnesiaAssistant.Query.html#delete/2"},{"type":"function","title":"MnesiaAssistant.Query.delete/3","doc":"By using this function, you will be able to delete a record from\nthe table based on the key that you desire.\n\n**Note**: The LockKind ([:write, :sticky_write]) argument is used to control the\nlocking behavior during the delete operation, which can influence data consistency and\nconcurrency control for the operation.","ref":"MnesiaAssistant.Query.html#delete/3"},{"type":"function","title":"Example: - MnesiaAssistant.Query.delete/3","doc":"```elixir\n  MnesiaAssistant.Query.delete(Person, 1, :write)\n  # OR\n  MnesiaAssistant.Query.delete(Person, 1)\n```","ref":"MnesiaAssistant.Query.html#delete/3-example"},{"type":"function","title":"MnesiaAssistant.Query.delete_object/1","doc":"To use `:mnesia.delete_object/3` in Elixir, you need to specify the table from\nwhich to delete (Tab), the complete record to be deleted (Rec),\nand the lock type (LockKind). This function is particularly useful\nwhen you need to delete a specific record and you know the entire tuple\nstructure of that record.","ref":"MnesiaAssistant.Query.html#delete_object/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.delete_object/1","doc":"```elixir\n  record_to_delete = {Person, 2, \"John Doe\", 30}\n\n  MnesiaAssistant.Query.delete_object(record_to_delete)\n  # OR\n  MnesiaAssistant.Query.delete_object(Person, record_to_delete, :write)\n```","ref":"MnesiaAssistant.Query.html#delete_object/1-example"},{"type":"function","title":"MnesiaAssistant.Query.delete_object/3","doc":"Read `delete_object/1` document.","ref":"MnesiaAssistant.Query.html#delete_object/3"},{"type":"function","title":"MnesiaAssistant.Query.dirty_delete/1","doc":"Read `dirty_delete/1` document.","ref":"MnesiaAssistant.Query.html#dirty_delete/1"},{"type":"function","title":"MnesiaAssistant.Query.dirty_delete/2","doc":"Dirty equivalent of the function `delete/2`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_delete/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_delete/2","doc":"```elixir\n  MnesiaAssistant.Query.dirty_delete(Person, 20)\n  # OR\n  MnesiaAssistant.Query.dirty_delete({Person, 20})\n```","ref":"MnesiaAssistant.Query.html#dirty_delete/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_delete_object/1","doc":"Dirty equivalent of the function `delete_object/1`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_delete_object/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_delete_object/1","doc":"```elixir\n  Query.dirty_delete_object({Person, :_, \"Mishka\", :_})\n```","ref":"MnesiaAssistant.Query.html#dirty_delete_object/1-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_delete_object/2","doc":"Read `dirty_delete_object/1` document.","ref":"MnesiaAssistant.Query.html#dirty_delete_object/2"},{"type":"function","title":"MnesiaAssistant.Query.dirty_first/1","doc":"Dirty equivalent of the function `first/1`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_first/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_first/1","doc":"```elixir\n  MnesiaAssistant.Query.dirty_first(Person)\n```","ref":"MnesiaAssistant.Query.html#dirty_first/1-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_index_match_object/2","doc":"Dirty equivalent of the function `index_match_object/2`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_index_match_object/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_index_match_object/2","doc":"```elixir\n  MnesiaAssistant.Query.dirty_index_match_object({Person, :_, \"Mishka\", :_}, 30)\n  MnesiaAssistant.Query.dirty_index_match_object(Person, {Person, :_, \"Mishka\", :_}, 30)\n```","ref":"MnesiaAssistant.Query.html#dirty_index_match_object/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_index_match_object/3","doc":"Read `dirty_index_match_object/2` document.","ref":"MnesiaAssistant.Query.html#dirty_index_match_object/3"},{"type":"function","title":"MnesiaAssistant.Query.dirty_index_read/3","doc":"Dirty equivalent of the function `index_read/3`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_index_read/3"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_index_read/3","doc":"```elixir\n  MnesiaAssistant.Query.dirty_index_read(Person, 20, :age)\n```\n\n> Attr = index_attr()","ref":"MnesiaAssistant.Query.html#dirty_index_read/3-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_last/1","doc":"Dirty equivalent of the function `last/1`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_last/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_last/1","doc":"```elixir\n  MnesiaAssistant.Query.dirty_last(Person)\n```","ref":"MnesiaAssistant.Query.html#dirty_last/1-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_match_object/1","doc":"Read `dirty_match_object/2` document.","ref":"MnesiaAssistant.Query.html#dirty_match_object/1"},{"type":"function","title":"MnesiaAssistant.Query.dirty_match_object/2","doc":"There is a distinction between this method and the `select` function,\n  which is that you are aware of the record that you wish to remove from the table.\n  It is like: `:mnesia.match_object({Person, :_, \"Mishka\", :_})`","ref":"MnesiaAssistant.Query.html#dirty_match_object/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_match_object/2","doc":"```elixir\n    alias MnesiaAssistant.Query\n\n    Query.dirty_match_object(Person, [:_, \"Mishka\", :_])\n    # OR\n    Query.dirty_match_object(Person, {Person, :_, \"Mishka\", :_})\n    # OR\n    Query.dirty_match_object({Person, :_, \"Mishka\", :_})\n```\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_match_object/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_next/2","doc":"Dirty equivalent of the function `next/2`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_next/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_next/2","doc":"```elixir\n  MnesiaAssistant.Query.dirty_next(Person, 20)\n```","ref":"MnesiaAssistant.Query.html#dirty_next/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_prev/2","doc":"Dirty equivalent of the function `prev/2`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_prev/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_prev/2","doc":"```elixir\n  MnesiaAssistant.Query.dirty_prev(Person, 20)\n```","ref":"MnesiaAssistant.Query.html#dirty_prev/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_read/2","doc":"The database can be accessed through the use of this function to retrieve a record.\nIt is important to remind you that if you are seeking for a\nreliable assurance for the retrieval of data, you can utilise transaction.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_read/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_read/2","doc":"```elixir\n  alias MnesiaAssistant.Query\n\n  Query.dirty_read(Person, 20)\n```","ref":"MnesiaAssistant.Query.html#dirty_read/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_select/2","doc":"Read `dirty_select/4` document.","ref":"MnesiaAssistant.Query.html#dirty_select/2"},{"type":"function","title":"MnesiaAssistant.Query.dirty_select/4","doc":"Dirty equivalent of the function `select/5`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_select/4"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_select/4","doc":"```elixir\n  MnesiaAssistant.Query.dirty_select(Person, [{{Person, :\"$1\", :\"$2\", :\"$3\"}, [{:>, :\"$1\", 3}], [:\"$$\"]}])\n  # OR\n  MnesiaAssistant.Query.dirty_select(\n    Person,\n    [:\"$1\", :\"$2\", :\"$3\"],\n    [{:>, :\"$1\", 3}],\n    [:\"$$\"]\n  )\n```","ref":"MnesiaAssistant.Query.html#dirty_select/4-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_update_counter/2","doc":"Mnesia has no special counter records. However, records of the form `{Tab, Key, Integer}`\ncan be used as (possibly `disc-resident`) counters when Tab is a set.\nThis function updates a counter with a positive or negative number.\nHowever, counters can never become less than zero. There are two significant\ndifferences between this function and the action of first reading the record,\nperforming the arithmetic, and then writing the record:\n\n1. It is much more efficient.\n2. `mnesia:dirty_update_counter/3` is performed as an atomic operation although it is\nnot protected by a transaction.\n\n---\n\nIf two processes perform `mnesia:dirty_update_counter/3` simultaneously,\nboth updates take effect without the risk of losing one of the updates.\nThe new value NewVal of the counter is returned.\n\n> If Key does not exist, a new record is created with value Incr if it is larger than 0,\n> otherwise it is set to 0.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_update_counter/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_update_counter/2","doc":"```elixir\n  MnesiaAssistant.Query.dirty_update_counter(:counters, :visits, 1)\n  # OR+\n  MnesiaAssistant.Query.dirty_update_counter({:counters, :visits}, 1)\n```","ref":"MnesiaAssistant.Query.html#dirty_update_counter/2-example"},{"type":"function","title":"MnesiaAssistant.Query.dirty_update_counter/3","doc":"Read `dirty_update_counter/2` document.","ref":"MnesiaAssistant.Query.html#dirty_update_counter/3"},{"type":"function","title":"MnesiaAssistant.Query.dirty_write/1","doc":"Read `dirty_write/2` document.","ref":"MnesiaAssistant.Query.html#dirty_write/1"},{"type":"function","title":"MnesiaAssistant.Query.dirty_write/2","doc":"Dirty equivalent of the function `write/1`.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#dirty_write/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.dirty_write/2","doc":"```elixir\n  updated_person = {Person, id, name, new_age}\n\n  MnesiaAssistant.Query.dirty_write(Person, updated_person)\n  # OR\n  MnesiaAssistant.Query.dirty_write(updated_person)\n```","ref":"MnesiaAssistant.Query.html#dirty_write/2-example"},{"type":"function","title":"MnesiaAssistant.Query.first/1","doc":"Returns first record of the table concerned.","ref":"MnesiaAssistant.Query.html#first/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.first/1","doc":"```elixir\n  MnesiaAssistant.Query.first(Person)\n```","ref":"MnesiaAssistant.Query.html#first/1-example"},{"type":"function","title":"MnesiaAssistant.Query.foldl/3","doc":"it is like `Enum.reduce`.","ref":"MnesiaAssistant.Query.html#foldl/3"},{"type":"function","title":"Example: - MnesiaAssistant.Query.foldl/3","doc":"```elixir\n  initial_acc = 0\n\n  fun = fn {:people, _id, _name, age}, acc ->\n    acc + age\n  end\n\n  MnesiaAssistant.Query.foldl(Person, initial_acc, fun)\n  # OR\n  MnesiaAssistant.Query.foldl(Person, initial_acc, fun, :write)\n  # OR\n  MnesiaAssistant.Transaction.transaction(fn ->\n    MnesiaAssistant.Query.foldl(Person, initial_acc, fun)\n  end)\n```","ref":"MnesiaAssistant.Query.html#foldl/3-example"},{"type":"function","title":"MnesiaAssistant.Query.foldl/4","doc":"Read `foldl/3` document.","ref":"MnesiaAssistant.Query.html#foldl/4"},{"type":"function","title":"MnesiaAssistant.Query.foldr/3","doc":"Works exactly like foldl/3 but iterates the table in the opposite order for the `ordered_set`\ntable type. For all other table types, `foldr/3` and `foldl/3` are synonyms.\n\nRead `foldl/3` document.","ref":"MnesiaAssistant.Query.html#foldr/3"},{"type":"function","title":"MnesiaAssistant.Query.foldr/4","doc":"Read `foldr/3` document.","ref":"MnesiaAssistant.Query.html#foldr/4"},{"type":"function","title":"MnesiaAssistant.Query.index_match_object/2","doc":"In a manner similar to the function `mnesia:index_read/3`, any index information can\nbe used when trying to match records. This function takes a pattern that\nobeys the same rules as the function `mnesia:match_object/3`, except that this\nfunction requires the following conditions:\n\n* The table Tab must have an index on position Pos.\n* The element in position Pos in Pattern must be bound. Pos is an integer (`#record.Field`) or an attribute name.\n\n> The two index search functions described here are automatically\n> started when searching tables with qlc list comprehensions and\n> also when using the low-level `mnesia:[dirty_]match_object` functions.\n\nThe semantics of this function is context-sensitive. For details,\n`see mnesia:activity/4`. In transaction-context, it acquires a lock of type\nLockKind on the entire table or on a single record. Currently,\nthe lock type read is supported.","ref":"MnesiaAssistant.Query.html#index_match_object/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.index_match_object/2","doc":"```elixir\n  MnesiaAssistant.Query.index_match_object({Person, :_, \"Mishka\", :_}, 30)\n  MnesiaAssistant.Query.index_match_object(Person, {Person, :_, \"Mishka\", :_}, 30, :write)\n```","ref":"MnesiaAssistant.Query.html#index_match_object/2-example"},{"type":"function","title":"MnesiaAssistant.Query.index_match_object/4","doc":"","ref":"MnesiaAssistant.Query.html#index_match_object/4"},{"type":"function","title":"MnesiaAssistant.Query.index_read/3","doc":"Assume that there is an index on position Pos for a certain record type.\nThis function can be used to read the records without knowing the actual `key`\nfor the record. For example, with an index in position 1 of table person,\nthe call `mnesia:index_read(person, 36, #person.age)` returns a list of all\npersons with age 36. Pos can also be an attribute name (atom),\nbut if the notation `mnesia:index_read(person, 36, age)` is used,\nthe field position is searched for in runtime, for each call.","ref":"MnesiaAssistant.Query.html#index_read/3"},{"type":"function","title":"Example: - MnesiaAssistant.Query.index_read/3","doc":"```elixir\n  MnesiaAssistant.Query.index_read(Person, 20, :age)\n```","ref":"MnesiaAssistant.Query.html#index_read/3-example"},{"type":"function","title":"MnesiaAssistant.Query.is_transaction?/0","doc":"When this function is executed inside a transaction-context, it returns true, otherwise false.","ref":"MnesiaAssistant.Query.html#is_transaction?/0"},{"type":"function","title":"MnesiaAssistant.Query.last/1","doc":"Returns last record of the table concerned.","ref":"MnesiaAssistant.Query.html#last/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.last/1","doc":"```elixir\n  MnesiaAssistant.Query.last(Person)\n```","ref":"MnesiaAssistant.Query.html#last/1-example"},{"type":"function","title":"MnesiaAssistant.Query.match_object/1","doc":"Read `match_object/2` document.","ref":"MnesiaAssistant.Query.html#match_object/1"},{"type":"function","title":"MnesiaAssistant.Query.match_object/2","doc":"There is a distinction between this method and the `select` function,\nwhich is that you are aware of the record that you wish to remove from the table.\nIt is like: `:mnesia.match_object({Person, :_, \"Mishka\", :_})`","ref":"MnesiaAssistant.Query.html#match_object/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.match_object/2","doc":"```elixir\n  alias MnesiaAssistant.Query\n\n  Query.match_object(Person, [:_, \"Mishka\", :_])\n  # OR\n  Query.match_object(Person, [:_, \"Mishka\", :_], :write)\n  # OR\n  Query.match_object(Person, {Person, :_, \"Mishka\", :_}, :write)\n  # OR\n  Query.match_object({Person, :_, \"Mishka\", :_})\n```","ref":"MnesiaAssistant.Query.html#match_object/2-example"},{"type":"function","title":"MnesiaAssistant.Query.match_object/3","doc":"Read `match_object/2` document.","ref":"MnesiaAssistant.Query.html#match_object/3"},{"type":"function","title":"MnesiaAssistant.Query.next/2","doc":"Returns next record of the table concerned from your selected :id as the key.","ref":"MnesiaAssistant.Query.html#next/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.next/2","doc":"```elixir\n  MnesiaAssistant.Query.next(Person, 1)\n```","ref":"MnesiaAssistant.Query.html#next/2-example"},{"type":"function","title":"MnesiaAssistant.Query.prev/2","doc":"Returns prev record of the table concerned from your selected :id as the key.","ref":"MnesiaAssistant.Query.html#prev/2"},{"type":"function","title":"Example: - MnesiaAssistant.Query.prev/2","doc":"```elixir\n  MnesiaAssistant.Query.prev(Person, 1)\n```","ref":"MnesiaAssistant.Query.html#prev/2-example"},{"type":"function","title":"MnesiaAssistant.Query.read/1","doc":"The database can be accessed through the use of this function to retrieve a record.\nIt is important to remind you that if you are seeking for a\nreliable assurance for the retrieval of data, you can utilise transaction.","ref":"MnesiaAssistant.Query.html#read/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.read/1","doc":"```elixir\n  MnesiaAssistant.Transaction.transaction(fn ->\n    MnesiaAssistant.Query.read({Person, 20})\n  end)\n  # OR\n  MnesiaAssistant.Query.read(Person, 20)\n  # OR use one of @table_lock_types [:read, :write, :sticky_write]\n  MnesiaAssistant.Query.read(Person, 20, lock_type)\n```\n\n> Reads all records from table Tab with key Key.\n> This function has the same semantics regardless of the location of Tab.\n> If the table is of type `bag`, the function `mnesia:read(Tab, Key)` can return\n> an arbitrarily long list. If the table is of type set, the list\n> is either of length `1`, or `[]`.\n\n**Note**: The LockKind ([:read, :write, :sticky_write]) argument is used to control the\nlocking behavior during the read operation, which can influence data consistency and\nconcurrency control for the operation.","ref":"MnesiaAssistant.Query.html#read/1-example"},{"type":"function","title":"MnesiaAssistant.Query.read/2","doc":"","ref":"MnesiaAssistant.Query.html#read/2"},{"type":"function","title":"MnesiaAssistant.Query.read/3","doc":"","ref":"MnesiaAssistant.Query.html#read/3"},{"type":"function","title":"MnesiaAssistant.Query.s_delete/1","doc":"It is like `MnesiaAssistant.Query.delete(table, key, :sticky_write)`.\nFor more information read `delete/3` or `mnesia:delete(Tab, Key, sticky_write)`.","ref":"MnesiaAssistant.Query.html#s_delete/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.s_delete/1","doc":"```elixir\n  MnesiaAssistant.Query.s_delete(Person, 20)\n```","ref":"MnesiaAssistant.Query.html#s_delete/1-example"},{"type":"function","title":"MnesiaAssistant.Query.s_delete_object/1","doc":"It is like `MnesiaAssistant.Query.delete_object(table, record, :sticky_write)`\nwhere Tab is element(1, Record).\nFor more information read `delete_object/3` or `mnesia:delete_object(Tab, Record, sticky_write)`.","ref":"MnesiaAssistant.Query.html#s_delete_object/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.s_delete_object/1","doc":"```elixir\n  MnesiaAssistant.Query.s_delete_object({Person, 2, \"John Doe\", 30})\n```","ref":"MnesiaAssistant.Query.html#s_delete_object/1-example"},{"type":"function","title":"MnesiaAssistant.Query.s_write/1","doc":"It is like `MnesiaAssistant.Query.write(Person, updated_person, :sticky_write)` or\n`mnesia:write(Tab, Record, sticky_write)`.\nFor more information read `write/3`.","ref":"MnesiaAssistant.Query.html#s_write/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.s_write/1","doc":"```elixir\n  updated_person = {Person, id, name, new_age}\n\n  MnesiaAssistant.Query.s_write(updated_person)\n```","ref":"MnesiaAssistant.Query.html#s_write/1-example"},{"type":"function","title":"MnesiaAssistant.Query.select/1","doc":"Read `select/5` document.","ref":"MnesiaAssistant.Query.html#select/1"},{"type":"function","title":"MnesiaAssistant.Query.select/2","doc":"Read `select/5` document.","ref":"MnesiaAssistant.Query.html#select/2"},{"type":"function","title":"MnesiaAssistant.Query.select/3","doc":"Read `select/5` document.","ref":"MnesiaAssistant.Query.html#select/3"},{"type":"function","title":"MnesiaAssistant.Query.select/4","doc":"Read `select/5` document.","ref":"MnesiaAssistant.Query.html#select/4"},{"type":"function","title":"MnesiaAssistant.Query.select/5","doc":"The `select/5` function allows you to specify a custom query using any\noperator or function in the Elixir language (or Erlang for that matter).","ref":"MnesiaAssistant.Query.html#select/5"},{"type":"function","title":"Example: - MnesiaAssistant.Query.select/5","doc":"```elixir\n  alias MnesiaAssistant.Query\n\n  Query.select(Person, [{{Person, :\"$1\", :\"$2\", :\"$3\"}, [{:>, :\"$1\", 3}], [:\"$$\"]}])\n  # OR you can use this helper `select/5`\n  Query.select(\n    Person,\n    [:\"$1\", :\"$2\", :\"$3\"],\n    [{:>, :\"$1\", 3}],\n    :write,\n    [result_type: [:\"$$\"], lock_type: :write]\n  )\n```","ref":"MnesiaAssistant.Query.html#select/5-example"},{"type":"function","title":"MnesiaAssistant.Query.sync_dirty/1","doc":"Calls the Fun in a context that is not protected by a transaction.\nThe `Mnesia` function calls performed in the Fun are mapped to the corresponding\ndirty functions. It is performed in almost the same context as `mnesia:async_dirty/1,2`.\nThe difference is that the operations are performed synchronously.\nThe caller waits for the updates to be performed on all active replicas\nbefore the Fun returns. For details, see `mnesia:activity/4` and the User's Guide.\n\n> **Note**: In the context of `mnesia`, the `dirty` keyword indicates that it\n> encompasses the maximum speed, but it does not guarantee that it will execute correctly.","ref":"MnesiaAssistant.Query.html#sync_dirty/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.sync_dirty/1","doc":"```elixir\n  MnesiaAssistant.Query.sync_dirty(fn -> something end)\n  # OR\n  MnesiaAssistant.Query.sync_dirty(fn -> something end, args)\n```","ref":"MnesiaAssistant.Query.html#sync_dirty/1-example"},{"type":"function","title":"MnesiaAssistant.Query.sync_dirty/2","doc":"Read `sync_dirty/1` document.","ref":"MnesiaAssistant.Query.html#sync_dirty/2"},{"type":"function","title":"MnesiaAssistant.Query.wread/1","doc":"It is like `read/3` with `:write` LockKind.","ref":"MnesiaAssistant.Query.html#wread/1"},{"type":"function","title":"Example: - MnesiaAssistant.Query.wread/1","doc":"```elixir\n  MnesiaAssistant.Query.wread(Person, 20)\n```","ref":"MnesiaAssistant.Query.html#wread/1-example"},{"type":"function","title":"MnesiaAssistant.Query.write/1","doc":"Read `write/3` document.","ref":"MnesiaAssistant.Query.html#write/1"},{"type":"function","title":"MnesiaAssistant.Query.write/3","doc":"The following function will help you update a record of a table\nbased on a specific key.\n\n**Note**: The LockKind ([:write, :sticky_write]) argument is used to control the\nlocking behavior during the write operation, which can influence data consistency and\nconcurrency control for the operation.","ref":"MnesiaAssistant.Query.html#write/3"},{"type":"function","title":"Example: - MnesiaAssistant.Query.write/3","doc":"```elixir\n  updated_person = {Person, id, name, new_age}\n\n  MnesiaAssistant.Query.write(Person, updated_person)\n  # OR\n  MnesiaAssistant.Query.write(Person, updated_person, :write)\n  # OR\n  MnesiaAssistant.Query.write(updated_person)\n```","ref":"MnesiaAssistant.Query.html#write/3-example"},{"type":"module","title":"MnesiaAssistant.Schema","doc":"This module not only provides a number of tools to better cover a real project,\nbut it also organises functions linked to Schema in a single location.","ref":"MnesiaAssistant.Schema.html"},{"type":"function","title":"MnesiaAssistant.Schema.activate_checkpoint/1","doc":"In Mnesia, the concept of `checkpoints` as it might be understood in other\ndatabase systems (specific points in time to which you can revert the database state)\nis not directly exposed through a simple API call like `:mnesia.activate_checkpoint`.\nMnesia's model for data recovery, consistency, and fault tolerance is built\naround its transactional model, replication, and `backup`/`restore` functionalities.\n\n```erlang\n {name, Name}\n | {max, [table()]}\n | {min, [table()]}\n | {allow_remote, boolean()}\n | {ram_overrides_dump, boolean()}\n```","ref":"MnesiaAssistant.Schema.html#activate_checkpoint/1"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.activate_checkpoint/1","doc":"```elixir\n  MnesiaAssistant.Schema.activate_checkpoint(args)\n```","ref":"MnesiaAssistant.Schema.html#activate_checkpoint/1-example"},{"type":"function","title":"MnesiaAssistant.Schema.create_dir/0","doc":"Using the `mnesia` configuration, this straightforward method will assist\nyou in determining whether or not the path that you have supplied is present.\nWhen it does not already exist, it develops it.","ref":"MnesiaAssistant.Schema.html#create_dir/0"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.create_dir/0","doc":"```elixir\n  MnesiaAssistant.Schema.create_dir()\n```","ref":"MnesiaAssistant.Schema.html#create_dir/0-example"},{"type":"function","title":"MnesiaAssistant.Schema.create_schema/1","doc":"You will need to establish a `schema` in order to begin utilising `Mnesia`\nin a project; this function will automatically create the schema for you.\n\n> Note that prior to the creation of the schema, it is necessary\n> to determine whether or not the storage path that was introduced\n> by the configuration already exists. Assuming that it does not already exist,\n> this path ought to be made. see more information `create_dir()/0`","ref":"MnesiaAssistant.Schema.html#create_schema/1"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.create_schema/1","doc":"```elixir\n  MnesiaAssistant.Schema.create_schema([node()])\n```","ref":"MnesiaAssistant.Schema.html#create_schema/1-example"},{"type":"function","title":"MnesiaAssistant.Schema.deactivate_checkpoint/1","doc":"For deactivating `activate_checkpoint/1`.","ref":"MnesiaAssistant.Schema.html#deactivate_checkpoint/1"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.deactivate_checkpoint/1","doc":"```elixir\n  MnesiaAssistant.Schema.deactivate_checkpoint(name)\n```","ref":"MnesiaAssistant.Schema.html#deactivate_checkpoint/1-example"},{"type":"function","title":"MnesiaAssistant.Schema.delete_schema/1","doc":"In the same way that you are able to generate a schema for a particular node,\nyou are also able to delete it from your project.","ref":"MnesiaAssistant.Schema.html#delete_schema/1"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.delete_schema/1","doc":"```elixir\n  MnesiaAssistant.Schema.delete_schema([node()])\n```","ref":"MnesiaAssistant.Schema.html#delete_schema/1-example"},{"type":"function","title":"MnesiaAssistant.Schema.schema/0","doc":"By means of this function, you can see information about `Schema`.\nIt should be noted that this function is the same as the\n`MnesiaAssistant.Information.info/1` function with the `:schema` input.","ref":"MnesiaAssistant.Schema.html#schema/0"},{"type":"function","title":"Example: - MnesiaAssistant.Schema.schema/0","doc":"```elixir\n  MnesiaAssistant.Schema.schema()\n  # OR\n  MnesiaAssistant.Schema.schema(table)\n```","ref":"MnesiaAssistant.Schema.html#schema/0-example"},{"type":"function","title":"MnesiaAssistant.Schema.schema/1","doc":"","ref":"MnesiaAssistant.Schema.html#schema/1"},{"type":"module","title":"MnesiaAssistant.Snmp","doc":"This module provides Simple Network Management Protocol (SNMP) functionality for mnesia.\n> TODO: This module needs to completely cover all of the functions that are\n> relevant to it.\n> In the event that you have mastered this section, kindly submit a Pull Request\n> for this section.","ref":"MnesiaAssistant.Snmp.html"},{"type":"function","title":"MnesiaAssistant.Snmp.snmp_close_table/1","doc":"TODO: Neet to be completed.","ref":"MnesiaAssistant.Snmp.html#snmp_close_table/1"},{"type":"function","title":"MnesiaAssistant.Snmp.snmp_get_mnesia_key/2","doc":"TODO: Neet to be completed.","ref":"MnesiaAssistant.Snmp.html#snmp_get_mnesia_key/2"},{"type":"function","title":"MnesiaAssistant.Snmp.snmp_get_next_index/2","doc":"TODO: Neet to be completed.","ref":"MnesiaAssistant.Snmp.html#snmp_get_next_index/2"},{"type":"function","title":"MnesiaAssistant.Snmp.snmp_get_row/2","doc":"TODO: Neet to be completed.","ref":"MnesiaAssistant.Snmp.html#snmp_get_row/2"},{"type":"function","title":"MnesiaAssistant.Snmp.snmp_open_table/2","doc":"TODO: Neet to be completed.","ref":"MnesiaAssistant.Snmp.html#snmp_open_table/2"},{"type":"module","title":"MnesiaAssistant.Table","doc":"Within this module, you will find all of the functions that you require in order to operate with a table in Mnesia.","ref":"MnesiaAssistant.Table.html"},{"type":"function","title":"MnesiaAssistant.Table.add_table_copy/3","doc":"Makes another copy of a table on the Node you want. Argument Type must be either of the\natoms `ram_copies`, `disc_copies`, or `disc_only_copies`. For example, the following call ensures\nthat a disc replica of the person table also exists at node Node:","ref":"MnesiaAssistant.Table.html#add_table_copy/3"},{"type":"function","title":"Example: - MnesiaAssistant.Table.add_table_copy/3","doc":"```elixir\n   MnesiaAssistant.Table.add_table_copy(Person, A_NODE, :disc_copies)\n```","ref":"MnesiaAssistant.Table.html#add_table_copy/3-example"},{"type":"function","title":"MnesiaAssistant.Table.add_table_index/2","doc":"Table indexes can be used whenever the user wants to use frequently some other field than the key\nfield to look up records. If this other field has an associated index,\nthese lookups can occur in constant time and space. For example, if your application wishes to use field `age`\nto find efficiently all persons with a specific age, it can be a good idea to have an index on field age.\nThis can be done with the following call:","ref":"MnesiaAssistant.Table.html#add_table_index/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.add_table_index/2","doc":"```elixir\n MnesiaAssistant.Table.add_table_index(Person, :age)\n```","ref":"MnesiaAssistant.Table.html#add_table_index/2-example"},{"type":"function","title":"MnesiaAssistant.Table.all_keys/1","doc":"Returns a list of all keys in a table.\nhe semantics of this function is context-sensitive. For more information, see `MnesiaAssistant.Transaction.activity/4`.\nIn `transaction-context`, it acquires a read lock on the entire table.","ref":"MnesiaAssistant.Table.html#all_keys/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.all_keys/1","doc":"```elixir\n    MnesiaAssistant.Table.all_keys(Person)\n```","ref":"MnesiaAssistant.Table.html#all_keys/1-example"},{"type":"function","title":"MnesiaAssistant.Table.change_table_access_mode/2","doc":"AcccessMode is by default the atom `read_write` but it can also be set to the atom `read_only`.\nIf `AccessMode` is set to `read_only`, updates to the table cannot be performed.\nAt startup, `Mnesia` always loads `read_only` tables locally regardless of when and if `Mnesia` is terminated on\nother nodes.","ref":"MnesiaAssistant.Table.html#change_table_access_mode/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.change_table_access_mode/2","doc":"```elixir\n  MnesiaAssistant.Table.change_table_access_mode(Person, :read_write) #  [:read_only, :read_write]\n```","ref":"MnesiaAssistant.Table.html#change_table_access_mode/2-example"},{"type":"function","title":"MnesiaAssistant.Table.change_table_copy_type/2","doc":"After the table has been created, it is possible that you will need to modify the way of copying data in a `Mnesia`\ntable in accordance with the logic of your program.\n\nTable copy types: `[:disc_only_copies, :disc_copies, :ram_copies]`","ref":"MnesiaAssistant.Table.html#change_table_copy_type/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.change_table_copy_type/2","doc":"```elixir\n MnesiaAssistant.Table.change_table_copy_type(Person, :disc_only_copies)\n```","ref":"MnesiaAssistant.Table.html#change_table_copy_type/2-example"},{"type":"function","title":"MnesiaAssistant.Table.change_table_load_order/2","doc":"Consider the following scenario: the existence of other tables is somewhat reliant on the existence of other tables,\nand the tables should be brought up in order based on a prioritization of the tables; therefore,\nthis function may be useful in this part.","ref":"MnesiaAssistant.Table.html#change_table_load_order/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.change_table_load_order/2","doc":"The LoadOrder priority is by default `0` (zero) but can be set to any integer.\nThe tables with the highest LoadOrder priority are loaded first at startup.","ref":"MnesiaAssistant.Table.html#change_table_load_order/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.change_table_load_order/2","doc":"```elixir\n  MnesiaAssistant.Table.change_table_load_order(Person, 10)\n```","ref":"MnesiaAssistant.Table.html#change_table_load_order/2-example"},{"type":"function","title":"MnesiaAssistant.Table.change_table_majority/2","doc":"This function is part of Mnesia's advanced features for handling distributed data consistency.\nThe majority property, when set to true, requires that a majority of replicas (nodes)\nfor a given table must acknowledge a write operation for it to be considered successful.\nThis can enhance data consistency in distributed environments at the cost of availability,","ref":"MnesiaAssistant.Table.html#change_table_majority/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.change_table_majority/2","doc":"Majority must be a boolean. Default is false. When true, a majority of the table replicas\nmust be available for an update to succeed. When used on fragmented tables,\nTab must be the base table name. Directly changing the majority setting on individual fragments is not allowed.","ref":"MnesiaAssistant.Table.html#change_table_majority/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.change_table_majority/2","doc":"```elixir\n  MnesiaAssistant.Table.change_table_majority(Person, true)\n  # OR\n  MnesiaAssistant.Table.change_table_majority(Person, false)\n```","ref":"MnesiaAssistant.Table.html#change_table_majority/2-example"},{"type":"function","title":"MnesiaAssistant.Table.clear_table/1","doc":"Deletes all entries in a table.","ref":"MnesiaAssistant.Table.html#clear_table/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.clear_table/1","doc":"```elixir\n   MnesiaAssistant.Table.clear_table(Person)\n```","ref":"MnesiaAssistant.Table.html#clear_table/1-example"},{"type":"function","title":"MnesiaAssistant.Table.count/1","doc":"It returns size of a table by using `table_info(module, :size)`.","ref":"MnesiaAssistant.Table.html#count/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.count/1","doc":"```elixir\n    MnesiaAssistant.Table.count(Person)\n```","ref":"MnesiaAssistant.Table.html#count/1-example"},{"type":"function","title":"MnesiaAssistant.Table.create_table/2","doc":"You are possible to generate a table in Mnesia by utilizing this function. During the process\nof creating the table, it is important to know that the first input, which is the name of the\ntable, and the second input, which is in the form of a list, are respectively options that you\nare required to apply to the table.\n\n> It is important to note that you should make an effort to have a proper implementation at the\n> beginning by thoroughly researching the possibilities that are dependent on your strategy.\n> This will ensure that you do not have to repeat the procedures with as many different functions as possible.","ref":"MnesiaAssistant.Table.html#create_table/2"},{"type":"function","title":"Erlang Documents - MnesiaAssistant.Table.create_table/2","doc":"- `{access_mode, Atom}` The access mode is by default the atom read_write but it can also be set to the atom read_only.\nIf AccessMode is set to read_only, updates to the table cannot be performed.\nAt startup, Mnesia always loads read_only table locally regardless of when and if Mnesia is terminated on other nodes.\nThis argument returns the access mode of the table. The access mode can be read_only or read_write.\n\n- `{attributes, AtomList}` is a list of the attribute names for the records that are supposed to populate the table.\nDefault is [key, val]. The table must at least have one extra attribute in addition to the key.\nWhen accessing single attributes in a record, it is not necessary, or even recommended, to hard code any\nattribute names as atoms. Use construct `record_info(fields, RecordName)` instead. It can be used for records\nof type RecordName.\n\n- `{disc_copies, Nodelist}`, where Nodelist is a list of the nodes where this table is supposed to have disc copies.\nIf a table replica is of type disc_copies, all write operations on this particular replica of the table are written\nto disc and to the RAM copy of the table.\nIt is possible to have a replicated table of type disc_copies on one node and another type on another node.\nDefault is [].\n\n- `{disc_only_copies, Nodelist}`, where Nodelist is a list of the nodes where this table is supposed to have\n`disc_only_copies`. A disc only table replica is kept on disc only and unlike the other replica types,\nthe contents of the replica do not reside in RAM. These replicas are considerably slower than replicas held in RAM.\n\n- `{index, Intlist}`, where Intlist is a list of attribute names (atoms) or record fields for which Mnesia is\nto build and maintain an extra index table. The qlc query compiler may be able to optimize queries\nif there are indexes available.\n\n- `{load_order, Integer}`. The load order priority is by default 0 `(zero)` but can be set to any integer.\nThe tables with the highest load order priority are loaded first at startup.\n\n- `{majority, Flag}`, where Flag must be a boolean. If true, any `(non-dirty)` update to the table is aborted,\nunless a majority of the table replicas are available for the commit. When used on a fragmented table,\nall `fragments` are given the same majority setting.\n\n- `{ram_copies, Nodelist}`, where Nodelist is a list of the nodes where this table is supposed to have RAM copies.\nA table replica of type ram_copies is not written to disc on a per transaction basis. ram_copies replicas can be\ndumped to disc with the function mnesia:dump_tables(Tabs). Default value for this attribute is `[node()]`.\n\n\n- `{record_name, Name}`, where Name must be an atom. All records stored in the table must have this name as the\nfirst element. It defaults to the same name as the table name.\n\n- `{snmp, SnmpStruct}`. For a description of SnmpStruct, see `mnesia:snmp_open_table/2`.\nIf this attribute is present in ArgList to `mnesia:create_table/2`, the table is immediately accessible by SNMP.\nTherefore applications that use SNMP to manipulate and control the system can be designed easily,\nsince Mnesia provides a direct mapping between the logical tables that make up an SNMP control\napplication and the physical data that makes up a `Mnesia` table.\n\n- `{storage_properties, [{Backend, Properties}]` forwards more properties to the back end storage.\nBackend can currently be ets or dets. Properties is a list of options sent to the back end storage during\ntable creation. Properties cannot contain properties already used by Mnesia, such as type or `named_table`.\n\nFor example:\n```erlang\nmnesia:create_table(table, [{ram_copies, [node()]}, {disc_only_copies, nodes()},\n       {storage_properties,\n       [{ets, [compressed]}, {dets, [{auto_save, 5000}]} ]}])\n```\n\n- `{type, Type}`, where Type must be either of the atoms set, `ordered_set`, or `bag`. Default is set. In a `set`,\nall records have unique keys. In a bag, several records can have the same key, but the record content is unique.\nIf a non-unique record is stored, the old conflicting records are overwritten.\n\nNotice that currently `ordered_set` is not supported for `disc_only_copies`.\n\n`{local_content, Bool}`, where Bool is `true` or `false`. Default is `false`.\n\nFor example, the following call creates the person table (defined earlier) and replicates it on two nodes:\n\n```erlang\nmnesia:create_table(person,\n    [{ram_copies, [N1, N2]},\n    {attributes, record_info(fields, person)}]).\n```\n\nIf it is required that Mnesia must build and maintain an extra index table on attribute address of all\nthe person records that are inserted in the table, the following code would be issued:\n\n```erlang\nmnesia:create_table(person,\n    [{ram_copies, [N1, N2]},\n     {index, [address]},\n     {attributes, record_info(fields, person)}]).\n ```\n\n The specification of index and attributes can be hard-coded as `{index, [2]}` and\n `{attributes, [name, age, address, salary, children]}`, respectively.\n\n `mnesia:create_table/2` writes records into the table schema. This function, and all other schema\n manipulation functions, are implemented with the normal transaction management system.\n This guarantees that schema updates are performed on all nodes in an atomic manner.","ref":"MnesiaAssistant.Table.html#create_table/2-erlang-documents"},{"type":"function","title":"Example: - MnesiaAssistant.Table.create_table/2","doc":"```elixir\n  MnesiaAssistant.Table.create_table(Person, attributes: [:id, :name, :family, :age])\n ```","ref":"MnesiaAssistant.Table.html#create_table/2-example"},{"type":"function","title":"MnesiaAssistant.Table.del_table_copy/2","doc":"","ref":"MnesiaAssistant.Table.html#del_table_copy/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.del_table_copy/2","doc":"Deletes the replica of table `Tab` at node `Node`. When the last replica is deleted with this function,\n  the table disappears entirely.\n\n  This function can also be used to delete a replica of the table named schema.\n  The Mnesia node is then removed. Notice that Mnesia must be stopped on the node first.","ref":"MnesiaAssistant.Table.html#del_table_copy/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.del_table_copy/2","doc":"```elixir\n     MnesiaAssistant.Table.del_table_copy(Person, A_NODE)\n  ```","ref":"MnesiaAssistant.Table.html#del_table_copy/2-example"},{"type":"function","title":"MnesiaAssistant.Table.del_table_index/2","doc":"Deletes the index on attribute with name `AttrName` (for example :age) in a table.","ref":"MnesiaAssistant.Table.html#del_table_index/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.del_table_index/2","doc":"```elixir\n   MnesiaAssistant.Table.del_table_index(Person, :age)\n```","ref":"MnesiaAssistant.Table.html#del_table_index/2-example"},{"type":"function","title":"MnesiaAssistant.Table.delete_table/1","doc":"Permanently deletes all replicas of table Tab.","ref":"MnesiaAssistant.Table.html#delete_table/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.delete_table/1","doc":"```elixir\n   MnesiaAssistant.Table.delete_table(Person)\n```","ref":"MnesiaAssistant.Table.html#delete_table/1-example"},{"type":"function","title":"MnesiaAssistant.Table.dirty_all_keys/1","doc":"Dirty equivalent of the function `all_keys/1`.","ref":"MnesiaAssistant.Table.html#dirty_all_keys/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.dirty_all_keys/1","doc":"```elixir\n    MnesiaAssistant.Table.dirty_all_keys(Person)\n```","ref":"MnesiaAssistant.Table.html#dirty_all_keys/1-example"},{"type":"function","title":"MnesiaAssistant.Table.ets/1","doc":"","ref":"MnesiaAssistant.Table.html#ets/1"},{"type":"function","title":"Experimental: - MnesiaAssistant.Table.ets/1","doc":"The assumption here is that you do not wish to have a warranty for your data and that you also desire a copy\nof the `ram_copies` document. When it comes to this section, speed is of the utmost importance,\nand you should concentrate on local `ets`.\nWhen you take into account all of these factors, this feature is really helpful.","ref":"MnesiaAssistant.Table.html#ets/1-experimental"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.ets/1","doc":"Calls the Fun in a raw context that is not protected by a transaction. The `Mnesia` function call is\nperformed in the Fun and performed directly on the local `ETS` tables on the assumption that\nthe local storage type is ram_copies and the tables are not replicated to other nodes.\nSubscriptions are not triggered and checkpoints are not updated, but it is extremely fast.\nThis function can also be applied to disc_copies tables if all operations are read only.\nFor details, see `mnesia:activity/4` and the User's Guide.\n\n> Notice that calling (nesting) a `mnesia:ets` inside a transaction-context inherits the transaction semantics.","ref":"MnesiaAssistant.Table.html#ets/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.ets/1","doc":"```elixir\n  fun = fn ->\n    # Use ETS to get all records from the :people table and count them\n    ets_table = :ets.tab2list(:people)\n    length(ets_table)\n  end\n\n  MnesiaAssistant.Table.ets(fun)\n  # OR\n  MnesiaAssistant.Table.ets(fn ->\n    MnesiaAssistant.Table.all_keys(module)\n  end)\n  # OR\n  MnesiaAssistant.Table.ets(fn -> Enum.each(list, &save_dirty/1) end)\n```","ref":"MnesiaAssistant.Table.html#ets/1-example"},{"type":"function","title":"MnesiaAssistant.Table.ets/2","doc":"Read `ets/1` document.","ref":"MnesiaAssistant.Table.html#ets/2"},{"type":"function","title":"MnesiaAssistant.Table.exists?/1","doc":"Checking if the desired table exists?","ref":"MnesiaAssistant.Table.html#exists?/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.exists?/1","doc":"```elixir\n  MnesiaAssistant.Table.exists?(Person)\n```","ref":"MnesiaAssistant.Table.html#exists?/1-example"},{"type":"function","title":"MnesiaAssistant.Table.force_load_table/1","doc":"The Mnesia algorithm for table load can lead to a situation where a table cannot be loaded.\nThis situation occurs when a node is started and Mnesia concludes, or suspects,\nthat another copy of the table was active after this local copy became inactive because of a system crash.\n\nIf this situation is not acceptable, this function can be used to override the strategy of\nthe Mnesia table load algorithm. This can lead to a situation where some transaction effects\nare lost with an inconsistent database as result, but for some applications high availability\nis more important than consistent data.","ref":"MnesiaAssistant.Table.html#force_load_table/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.force_load_table/1","doc":"```elixir\n  MnesiaAssistant.Table.force_load_table(Person)\n```","ref":"MnesiaAssistant.Table.html#force_load_table/1-example"},{"type":"function","title":"MnesiaAssistant.Table.is_bag?/1","doc":"Checking whether the desired table is of `bag` type or not?","ref":"MnesiaAssistant.Table.html#is_bag?/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.is_bag?/1","doc":"```elixir\n  MnesiaAssistant.Table.is_bag?(Person)\n```","ref":"MnesiaAssistant.Table.html#is_bag?/1-example"},{"type":"function","title":"MnesiaAssistant.Table.is_ordered_set?/1","doc":"Checking whether the desired table is of `ordered_set` type or not?","ref":"MnesiaAssistant.Table.html#is_ordered_set?/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.is_ordered_set?/1","doc":"```elixir\n  MnesiaAssistant.Table.is_ordered_set?(Person)\n```","ref":"MnesiaAssistant.Table.html#is_ordered_set?/1-example"},{"type":"function","title":"MnesiaAssistant.Table.is_set?/1","doc":"Checking whether the desired table is of `set` type or not?","ref":"MnesiaAssistant.Table.html#is_set?/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.is_set?/1","doc":"```elixir\n  MnesiaAssistant.Table.is_set?(Person)\n```","ref":"MnesiaAssistant.Table.html#is_set?/1-example"},{"type":"function","title":"MnesiaAssistant.Table.lock/2","doc":"","ref":"MnesiaAssistant.Table.html#lock/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.lock/2","doc":"- `lock(LockItem, LockKind)`\n\nLockItem =\n  {record, table(), Key :: term()} |\n  {table, table()} |\n  {global, Key :: term(), MnesiaNodes :: [node()]}\n\nLockKind = [:read, :write, :sticky_write, :load]\n\nWrite locks are normally acquired on all nodes where a replica of the table resides (and is active).\nRead locks are acquired on one node (the local node if a local replica exists).\nMost of the context-sensitive access functions acquire an implicit lock if they are started in a transaction-context.\nThe granularity of a lock can either be a single record or an entire table.\n\nThe normal use is to call the function without checking the return value, as it exits if it fails and the\ntransaction is restarted by the transaction manager. It returns all the locked nodes if a write lock is\nacquired and ok if it was a read lock.\n\nThe function `mnesia:lock/2` is intended to support explicit locking on tables, but is also intended for\nsituations when locks need to be acquired regardless of how tables are replicated.\nCurrently, two kinds of LockKind are supported:\n\n- `:write` Write locks are exclusive. This means that if one transaction manages to acquire a write lock on an item,\nno other transaction can acquire any kind of lock on the same item.\n\n- `read` Read locks can be shared. This means that if one transaction manages to acquire a read lock on an item,\nother transactions can also acquire a read lock on the same item. However,\nif someone has a read lock, no one can acquire a write lock at the same item.\nIf someone has a write lock, no one can acquire either a read lock or a write lock at the same item.\nConflicting lock requests are automatically queued if there is no risk of a deadlock. Otherwise the transaction must\nbe terminated and executed again. Mnesia does this automatically as long as the upper limit\nof the maximum retries is not reached. For details, see `mnesia:transaction/3`.\n\n> For the sake of completeness, sticky write locks are also described here even if a sticky write lock is not\n> supported by this function:\n\n- `sticky_write` Sticky write locks are a mechanism that can be used to optimize write lock acquisition.\nIf your application uses replicated tables mainly for fault tolerance (as opposed to read access optimization purpose),\nsticky locks can be the best option available.\n\nWhen a sticky write lock is acquired, all nodes are informed which node is locked. Then, sticky lock requests\nfrom the same node are performed as a local operation without any communication with other nodes.\nThe sticky lock lingers on the node even after the transaction ends. For details, see the User's Guide.\n\nCurrently, this function supports two kinds of LockItem:\n\n`{table, Tab}` This acquires a lock of type LockKind on the entire table Tab.\n\n`{global, GlobalKey, Nodes}` This acquires a lock of type LockKind on the global resource GlobalKey.\nThe lock is acquired on all active nodes in the Nodes list.\n\nLocks are released when the outermost transaction ends. The semantics of this function is context-sensitive.\nFor details, see `mnesia:activity/4`. In transaction-context, it acquires locks, otherwise it ignores the request.","ref":"MnesiaAssistant.Table.html#lock/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.lock/2","doc":"```elixir\n  MnesiaAssistant.Table.lock({:table, Person}, :load)\n```","ref":"MnesiaAssistant.Table.html#lock/2-example"},{"type":"function","title":"MnesiaAssistant.Table.move_table_copy/3","doc":"Moves the copy of table Tab from node `From` to node `To`.\n\n> The storage type is preserved. For example, a RAM table moved from one node remains\n> a RAM on the new node. Other transactions can still read and write in the table while it is being moved.\n\nThis function cannot be used on `local_content` tables.","ref":"MnesiaAssistant.Table.html#move_table_copy/3"},{"type":"function","title":"Example: - MnesiaAssistant.Table.move_table_copy/3","doc":"```elixir\n    MnesiaAssistant.Table.add_table_copy(Person, A_NODE, B_NODE)\n```","ref":"MnesiaAssistant.Table.html#move_table_copy/3-example"},{"type":"function","title":"MnesiaAssistant.Table.read_lock_table/1","doc":"Calls the function `lock({:table, Person}, :read)`","ref":"MnesiaAssistant.Table.html#read_lock_table/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.read_lock_table/1","doc":"```elixir\n    MnesiaAssistant.Table.read_lock_table(Person)\n```","ref":"MnesiaAssistant.Table.html#read_lock_table/1-example"},{"type":"function","title":"MnesiaAssistant.Table.set_master_nodes/1","doc":"","ref":"MnesiaAssistant.Table.html#set_master_nodes/1"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.set_master_nodes/1","doc":"For each table Mnesia determines its replica nodes (`TabNodes`) and starts `mnesia:set_master_nodes(Tab, TabMasterNodes)`.\nwhere `TabMasterNodes` is the intersection of `MasterNodes` and TabNodes. For semantics, `see mnesia:set_master_nodes/2`.","ref":"MnesiaAssistant.Table.html#set_master_nodes/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.set_master_nodes/1","doc":"```elixir\n   MnesiaAssistant.Table.set_master_nodes([node()])\n```","ref":"MnesiaAssistant.Table.html#set_master_nodes/1-example"},{"type":"function","title":"MnesiaAssistant.Table.set_master_nodes/2","doc":"","ref":"MnesiaAssistant.Table.html#set_master_nodes/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.set_master_nodes/2","doc":"If the application detects a communication failure (in a potentially partitioned network) that can\nhave caused an inconsistent database, it can use the function `mnesia:set_master_nodes(Tab, MasterNodes)`\nto define from which nodes each table is to be loaded. At startup, the `Mnesia` normal table load\nalgorithm is bypassed and the table is loaded from one of the master nodes defined for the table,\nregardless of when and if Mnesia terminated on other nodes. `MasterNodes` can only contain\nnodes where the table has a replica. If the `MasterNodes` list is empty,\nthe master node recovery mechanism for the particular table is reset, and the normal load\nmechanism is used at the next restart.\n\nThe master node setting is always local. It can be changed regardless if `Mnesia` is started or not.\n\nThe database can also become inconsistent if configuration parameter `max_wait_for_decision` is used or\nif `mnesia:force_load_table/1` is used.","ref":"MnesiaAssistant.Table.html#set_master_nodes/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.set_master_nodes/2","doc":"```elixir\n   MnesiaAssistant.Table.set_master_nodes(Person, [node()])\n```","ref":"MnesiaAssistant.Table.html#set_master_nodes/2-example"},{"type":"function","title":"MnesiaAssistant.Table.start_table/5","doc":"","ref":"MnesiaAssistant.Table.html#start_table/5"},{"type":"function","title":"MnesiaAssistant.Table.table/1","doc":"","ref":"MnesiaAssistant.Table.html#table/1"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.table/1","doc":"Returns a Query List Comprehension (`QLC`) query handle, see the `qlc(3)` manual page in STDLIB.\nThe module qlc implements a query language that can use Mnesia tables as sources of data.\nCalling `mnesia:table/1,2` is the means to make the mnesia table Tab usable to **`QLC`**.\n\nOption can contain Mnesia options or QLC options. Mnesia recognizes the following options\n(any other option is forwarded to QLC).\n\n- `{lock, Lock}`, where lock can be read or write. Default is read.\n`{n_objects,Number}`, where n_objects specifies (roughly) the number of objects returned from Mnesia to QLC.\nQueries to remote tables can need a larger chunk to reduce network overhead.\nBy default, 100 objects at a time are returned.\n\n- `{traverse, SelectMethod}`, where traverse determines the method to traverse the whole table (if needed).\nThe default method is select.\n\nThere are two alternatives for select:\n\n1. `select`. The table is traversed by calling `mnesia:select/4` and `mnesia:select/1`.\nThe match specification (the second argument of select/3) is assembled by QLC:\nsimple filters are translated into equivalent match specifications. More complicated filters need to\nbe applied to all objects returned by select/3 given a match specification that matches all objects.\n\n2. `{select, MatchSpec}`. As for select, the table is traversed by calling `mnesia:select/3` and `mnesia:select/1`.\nThe difference is that the match specification is explicitly given.\nThis is how to state match specifications that cannot easily be expressed within the syntax provided by QLC.\n\n```erlang\n# Options = Option | [Option]\n# Option = MnesiaOpt | QlcOption\n# MnesiaOpt = {traverse, SelectOp} | {lock, lock_kind()} | {n_objects, integer() >= 0}\n# SelectOp = select | {select, ets:match_spec()}\n# QlcOption = {key_equality, '==' | '=:='}\ntable(Tab :: table()) -> qlc:query_handle()\ntable(Tab :: table(), Options) -> qlc:query_handle()\n```\n\nTODO: We need to support `qlc` interface, Query interface to Mnesia, ETS, Dets, and so on.\n- **Ref**: https://www.erlang.org/doc/man/qlc.html","ref":"MnesiaAssistant.Table.html#table/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.table/1","doc":"```elixir\n    MnesiaAssistant.Table.table(Person)\n```","ref":"MnesiaAssistant.Table.html#table/1-example"},{"type":"function","title":"MnesiaAssistant.Table.table/2","doc":"Read `table/1` document.","ref":"MnesiaAssistant.Table.html#table/2"},{"type":"function","title":"MnesiaAssistant.Table.table_info/2","doc":"You can use this function to see the information of a table.\nThe `table_info/2` function takes two arguments. The first is the name of a Mnesia table.\nThe second is one of the following keys:\n\n- `:all` Returns a list of all local table information. Each element is a {InfoKey, ItemVal} tuple.\n\nNew InfoItems can be added and old undocumented InfoItems can be removed without notice.\n\n- `:access_mode` Returns the access mode of the table. The access mode can be read_only or read_write.\n\n- `:arity` Returns the arity of records in the table as specified in the schema.\n\n- `:attributes` Returns the table attribute names that are specified in the schema.\n\n- `:checkpoints` Returns the names of the currently active checkpoints, which involve this table on this node.\n\n- `:cookie` Returns a table cookie, which is a unique system-generated identifier for the table. The cookie is used internally to ensure that two different table definitions using the same table name cannot accidentally be intermixed. The cookie is generated when the table is created initially.\n\n- `:disc_copies` Returns the nodes where a disc_copy of the table resides according to the schema.\n\n- `:disc_only_copies` Returns the nodes where a disc_only_copy of the table resides according to the schema.\n\n- `:index` Returns the list of index position integers for the table.\n\n- `:load_node` Returns the name of the node that Mnesia loaded the table from. The structure of the returned value is unspecified, but can be useful for debugging purposes.\n\n- `:load_order` Returns the load order priority of the table. It is an integer and defaults to 0 (zero).\n\n- `:load_reason` Returns the reason of why Mnesia decided to load the table. The structure of the returned value is unspecified, but can be useful for debugging purposes.\n\n- `:local_content` Returns true or false to indicate if the table is configured to have locally unique content on each node.\n\n- `:master_nodes` Returns the master nodes of a table.\n\n- `:memory` Returns for ram_copies and disc_copies tables the number of words allocated in memory to the table on this node. For disc_only_copies tables the number of bytes stored on disc is returned.\n\n- `:ram_copies` Returns the nodes where a ram_copy of the table resides according to the schema.\n\n- `:record_name` Returns the record name, common for all records in the table.\n\n- `:size` Returns the number of records inserted in the table.\n\n- `:snmp` Returns the SNMP struct. [] means that the table currently has no SNMP properties.\n\n- `:storage_type` Returns the local storage type of the table. It can be disc_copies, ram_copies, disc_only_copies, or the atom unknown. unknown is returned for all tables that only reside remotely.\n\n- `:subscribers` Returns a list of local processes currently subscribing to local table events that involve this table on this node.\n\n- `:type` Returns the table type, which is bag, set, or ordered_set.\n\n- `:user_properties` Returns the user-associated table properties of the table. It is a list of the stored property records.\n\n- `:version` Returns the current version of the table definition. The table version is incremented when the table definition is changed. The table definition can be incremented directly when it has been changed in a schema transaction, or when a committed table definition is merged with table definitions from other nodes during startup.\n\n- `:where_to_read` Returns the node where the table can be read. If value nowhere is returned, either the table is not loaded or it resides at a remote node that is not running.\n\n- `:where_to_write` Returns a list of the nodes that currently hold an active replica of the table.\n\n- `:wild_pattern` Returns a structure that can be given to the various match functions for a certain table. A record tuple is where all record fields have value '_'.","ref":"MnesiaAssistant.Table.html#table_info/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.table_info/2","doc":"```elixir\n MnesiaAssistant.Table.table_info(:attributes)\n # OR\n MnesiaAssistant.Table.table_info(:all)\n```","ref":"MnesiaAssistant.Table.html#table_info/2-example"},{"type":"function","title":"MnesiaAssistant.Table.transform_table/3","doc":"When continuing or beginning to call a table from `Mnesia`, it is possible that you will be required to\nuse an anonymous function in order to convert the previous data into the new data.","ref":"MnesiaAssistant.Table.html#transform_table/3"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Table.transform_table/3","doc":"Applies argument Fun to all records in the table. Fun is a function that takes a record of the **`old`** type and\nreturns a transformed record of the **`new`** type.\nArgument Fun can also be the atom ignore, which indicates that only the metadata about\nthe table is updated. Use of ignore is not recommended, but included as a possibility for the user\ndo to an own transformation.\n\n**NewAttributeList** and **NewRecordName** specify the attributes and the new record type of the converted table.\nTable name always remains unchanged. If `record_name` is changed, only the `Mnesia` functions that use table\nidentifiers work, for example, `mnesia:write/3` works, but not `mnesia:write/1`.","ref":"MnesiaAssistant.Table.html#transform_table/3-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Table.transform_table/3","doc":"```elixir\ntransform_fun = fn ({id, name}) ->\n  # Return the new structure with a default age\n  {id, name, 30}\nend\n\nMnesiaAssistant.Transaction.transaction(fn ->\n  MnesiaAssistant.Table.transform_table(Person, transform_fun, [:id, :name, :age])\nend)\n# OR\n# MnesiaAssistant.Table.transform_table(Person, transform_fun, [:id, :name, :age])\n# OR\nMnesiaAssistant.Table.transform_table(Person, transform_fun, [:id, :name, :age], NewPerson)\n```","ref":"MnesiaAssistant.Table.html#transform_table/3-example"},{"type":"function","title":"MnesiaAssistant.Table.transform_table/4","doc":"","ref":"MnesiaAssistant.Table.html#transform_table/4"},{"type":"function","title":"MnesiaAssistant.Table.wait_for_tables/2","doc":"Some applications need to wait for certain tables to be accessible to do useful work.\n`mnesia:wait_for_tables/2` either hangs until all tables in TabList are accessible, or until `timeout` is reached.","ref":"MnesiaAssistant.Table.html#wait_for_tables/2"},{"type":"function","title":"Example: - MnesiaAssistant.Table.wait_for_tables/2","doc":"```elixir\n MnesiaAssistant.Table.wait_for_tables(Person, 5000)\n```","ref":"MnesiaAssistant.Table.html#wait_for_tables/2-example"},{"type":"function","title":"MnesiaAssistant.Table.wait_for_tables/3","doc":"","ref":"MnesiaAssistant.Table.html#wait_for_tables/3"},{"type":"function","title":"MnesiaAssistant.Table.write_lock_table/1","doc":"Calls the function `mnesia:lock({table, Tab}, write)`. Read `lock/2` document.","ref":"MnesiaAssistant.Table.html#write_lock_table/1"},{"type":"function","title":"Example: - MnesiaAssistant.Table.write_lock_table/1","doc":"```elixir\n  MnesiaAssistant.Table.write_lock_table(Person)\n```","ref":"MnesiaAssistant.Table.html#write_lock_table/1-example"},{"type":"type","title":"MnesiaAssistant.Table.table_type/0","doc":"","ref":"MnesiaAssistant.Table.html#t:table_type/0"},{"type":"module","title":"MnesiaAssistant.Transaction","doc":"In this module, there are functions that are related to Transactions or that are opposite to commands.","ref":"MnesiaAssistant.Transaction.html"},{"type":"function","title":"MnesiaAssistant.Transaction.abort/1","doc":"Termination of a `Mnesia` transaction means that an exception is thrown to an enclosing catch.\nMakes the transaction silently return the tuple `{:aborted, reason}`.\nThus, the expression catch `mnesia:abort(x)` (Erlang) does not terminate the transaction.","ref":"MnesiaAssistant.Transaction.html#abort/1"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.abort/1","doc":"```elixir\n  MnesiaAssistant.Transaction.abort(reason)\n```","ref":"MnesiaAssistant.Transaction.html#abort/1-example"},{"type":"function","title":"MnesiaAssistant.Transaction.activity/2","doc":"","ref":"MnesiaAssistant.Transaction.html#activity/2"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Transaction.activity/2","doc":"The code that executes inside the activity can consist of a series of table manipulation functions,\nwhich are performed in an `AccessContext`. Currently, the following access contexts are supported:\n\n- `transaction` Short for {transaction, infinity}\n\n- `{transaction, Retries}` Calls `mnesia:transaction(Fun, Args, Retries)`. Notice that the result from\nFun is returned if the transaction is successful (atomic), otherwise the function exits with an abort reason.\n\n- `sync_transaction` Short for {sync_transaction, infinity}\n\n- `{sync_transaction, Retries}` Calls mnesia:sync_transaction(Fun, Args, Retries).\nNotice that the result from Fun is returned if the transaction is successful (atomic),\notherwise the function exits with an abort reason.\n\n- `async_dirty` Calls `mnesia:async_dirty(Fun, Args)`.\n\n- `sync_dirty` `Calls mnesia:sync_dirty(Fun, Args)`.\n\n- `ets` Calls `mnesia:ets(Fun, Args)`.\n\nThis function (`mnesia:activity/4`) differs in an important way from the functions mnesia:transaction,\n`mnesia:sync_transaction`, `mnesia:async_dirty`, mnesia:sync_dirty, and `mnesia:ets`. Argument `AccessMod` is the\nname of a callback module, which implements the mnesia_access behavior.\nMnesia forwards calls to the following functions:\n\n- `mnesia:lock/2` (`read_lock_table/1`, `write_lock_table/1`)\n- `mnesia:write/3` (`write/1`, `s_write/1`)\n- `mnesia:delete/3` (`delete/1`, `s_delete/1`)\n- `mnesia:delete_object/3` (`delete_object/1`, `s_delete_object/1`)\n- `mnesia:read/3` (`read/1`, `wread/1`)\n- `mnesia:match_object/3` (`match_object/1`)\n- `mnesia:all_keys/1`\n- `mnesia:first/1`\n- `mnesia:last/1`\n- `mnesia:prev/2`\n- `mnesia:next/2`\n- `mnesia:index_match_object/4` (`index_match_object/2`)\n- `mnesia:index_read/3`\n- `mnesia:table_info/2`\n\nto the corresponding:\n\n- `AccessMod:lock(ActivityId, Opaque, LockItem, LockKind)`\n- `AccessMod:write(ActivityId, Opaque, Tab, Rec, LockKind)`\n- `AccessMod:delete(ActivityId, Opaque, Tab, Key, LockKind)`\n- `AccessMod:delete_object(ActivityId, Opaque, Tab, RecXS, LockKind)`\n- `AccessMod:read(ActivityId, Opaque, Tab, Key, LockKind)`\n- `AccessMod:match_object(ActivityId, Opaque, Tab, Pattern, LockKind)`\n- `AccessMod:all_keys(ActivityId, Opaque, Tab, LockKind)`\n- `AccessMod:first(ActivityId, Opaque, Tab)`\n- `AccessMod:last(ActivityId, Opaque, Tab)`\n- `AccessMod:prev(ActivityId, Opaque, Tab, Key)`\n- `AccessMod:next(ActivityId, Opaque, Tab, Key)`\n- `AccessMod:index_match_object(ActivityId, Opaque, Tab, Pattern, Attr, LockKind)`\n- `AccessMod:index_read(ActivityId, Opaque, Tab, SecondaryKey, Attr, LockKind)`\n- `AccessMod:table_info(ActivityId, Opaque, Tab, InfoItem)`\n\nActivityId is a record that represents the identity of the enclosing Mnesia activity. The first field (obtained with element(1, ActivityId)) contains an atom, which can be interpreted as the activity type: ets, `async_dirty`, `sync_dirty`, or tid. tid means that the activity is a transaction. The structure of the rest of the identity record is internal to Mnesia.\n\n**`Opaque` is an opaque data structure that is internal to Mnesia.**\n\n> Calls `mnesia:activity(AccessContext, Fun, Args, AccessMod)`, where AccessMod is the default\n> access callback module obtained by `mnesia:system_info(access_module)`. Args defaults to `[]` (empty list).","ref":"MnesiaAssistant.Transaction.html#activity/2-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.activity/2","doc":"```elixir\n  MnesiaAssistant.Transaction.activity(\n    :transaction,\n    fn -> MnesiaAssistant.Query.read(:table, id) end\n  )\n```\n\n> The following is a summary of the description: activity can be helpful anytime you need to utilise additional\n> alternatives and also change certain extreme functions; nevertheless, if your job is straightforward, extremely\n> obvious, and has a direct function, it is preferable to use its own function.","ref":"MnesiaAssistant.Transaction.html#activity/2-example"},{"type":"function","title":"MnesiaAssistant.Transaction.activity/4","doc":"Read `activity/2` document.","ref":"MnesiaAssistant.Transaction.html#activity/4"},{"type":"function","title":"MnesiaAssistant.Transaction.async_dirty/1","doc":"","ref":"MnesiaAssistant.Transaction.html#async_dirty/1"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Transaction.async_dirty/1","doc":"Calls the Fun in a context that is not protected by a transaction. The Mnesia function calls performed in the Fun are mapped to the corresponding dirty functions. **This still involves logging, replication, and subscriptions, but there is no locking, local transaction storage, or commit protocols involved**.\n\nCheckpoint retainers and indexes are updated, but they are updated dirty. As for normal `mnesia:dirty_*` operations, the operations are performed semi-asynchronously. For details, see `mnesia:activity/4` and the User's Guide.\n\nThe Mnesia tables can be manipulated without using transactions. This has some serious disadvantages, but is considerably faster, as the transaction manager is not involved and no locks are set. A dirty operation does, however, guarantee a certain level of consistency, and the dirty operations cannot return garbled records. All dirty operations provide location transparency to the programmer, and a program does not have to be aware of the whereabouts of a certain table to function.\n\nNotice that it is more than ten times more efficient to read records dirty than within a transaction.\n\nDepending on the application, it can be a good idea to use the dirty functions for certain operations. Almost all Mnesia functions that can be called within transactions have a dirty equivalent, which is much more efficient.\n\nHowever, notice that there is a risk that the database can be left in an inconsistent state if dirty operations are used to update it. Dirty operations are only to be used for performance reasons when it is absolutely necessary.\n\n> Notice that calling (nesting) `mnesia:[a]sync_dirty` inside a transaction-context inherits the transaction semantics.","ref":"MnesiaAssistant.Transaction.html#async_dirty/1-erlang-document"},{"type":"function","title":"Extera: - MnesiaAssistant.Transaction.async_dirty/1","doc":":mnesia.async_dirty/2 and :mnesia.async_dirty/1 are two functions in Mnesia that are utilised to perform operations on the database without locking the database and without waiting for the operation to be finished across all replicas.\nTo put it another way, these methods carry out the specified operation in an asynchronous and \"dirty\" fashion.\nThis means that they do not ensure `ACID` qualities, which stands for **atomicity**, **consistency**, **isolation**, and **durability**. As a result, they are more efficient than transactions, but they may also be less secure. `async_dirty` operations are helpful for use cases in which speed is of the utmost importance and the operation does not require strong consistency guarantees.","ref":"MnesiaAssistant.Transaction.html#async_dirty/1-extera"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.async_dirty/1","doc":"```elixir\n  fun = fn -> MnesiaAssistant.Query.write({Person, id, name, age}) end\n  MnesiaAssistant.Transaction.async_dirty(fun)\n```","ref":"MnesiaAssistant.Transaction.html#async_dirty/1-example"},{"type":"function","title":"MnesiaAssistant.Transaction.async_dirty/2","doc":"Read `async_dirty/1` document.","ref":"MnesiaAssistant.Transaction.html#async_dirty/2"},{"type":"function","title":"MnesiaAssistant.Transaction.ets/1","doc":"","ref":"MnesiaAssistant.Transaction.html#ets/1"},{"type":"function","title":"Erlang document: - MnesiaAssistant.Transaction.ets/1","doc":"Calls the Fun in a raw context that is not protected by a transaction. The Mnesia function call is performed in the Fun and performed directly on the local `ETS` tables on the assumption that the local storage type is **`ram_copies`** and the tables are not replicated to other nodes.\nSubscriptions are not triggered and checkpoints are not updated, but it is extremely fast.\nThis function can also be applied to **`disc_copies`** tables if all operations are read only. For details, see `mnesia:activity/4` and the User's Guide.\n\nNotice that calling (nesting) a `mnesia:ets` inside a **transaction-context** inherits the transaction semantics.","ref":"MnesiaAssistant.Transaction.html#ets/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.ets/1","doc":"```elixir\n  MnesiaAssistant.Transaction.ets(fn ->\n    MnesiaAssistant.Table.all_keys(module)\n  end)\n```\n\n> Remember that `ets/1` and `ets/2` allow for `ETS-lik`e operations but still within the constraints\n> and behavior of Mnesia. They can offer performance benefits for certain types of operations\n> but use them judiciously and with understanding of their limitations.","ref":"MnesiaAssistant.Transaction.html#ets/1-example"},{"type":"function","title":"MnesiaAssistant.Transaction.ets/2","doc":"Read `ets/1` document.","ref":"MnesiaAssistant.Transaction.html#ets/2"},{"type":"function","title":"MnesiaAssistant.Transaction.sync_transaction/1","doc":"Not only does it guarantee that the transaction is committed locally, but it also guarantees that\nthe modifications are properly replicated to all of the other nodes before the function returns.\nWhen using this synchronous replication strategy, it waits for confirmation from all of the nodes,\nwhich guarantees that all replicas are consistent as soon as the transaction is finished.","ref":"MnesiaAssistant.Transaction.html#sync_transaction/1"},{"type":"function","title":"Erlang docuemnt: - MnesiaAssistant.Transaction.sync_transaction/1","doc":"Waits until data have been committed and logged to disk (if disk is used) on every involved node before it returns, otherwise it behaves as `mnesia:transaction/[1,2,3]`.\n\nThis functionality can be used to avoid that one process overloads a database on another node.\n\n\n- `sync_transaction(Fun)`\n- `sync_transaction(Fun, Retries)`\n- `sync_transaction(Fun, Args :: [Arg :: term()])`\n- `sync_transaction(Fun, Args :: [Arg :: term()], Retries)`","ref":"MnesiaAssistant.Transaction.html#sync_transaction/1-erlang-docuemnt"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.sync_transaction/1","doc":"```elixir\n  alias MnesiaAssistant.Query\n\n  fun = fn ->\n    Query.write({Person, Query.dirty_last(Person) + 1, \"Mishka, 20})\n  end\n\n  MnesiaAssistant.Transaction.sync_transaction(fun)\n```","ref":"MnesiaAssistant.Transaction.html#sync_transaction/1-example"},{"type":"function","title":"MnesiaAssistant.Transaction.sync_transaction/2","doc":"Read `sync_transaction/1` document.","ref":"MnesiaAssistant.Transaction.html#sync_transaction/2"},{"type":"function","title":"MnesiaAssistant.Transaction.sync_transaction/3","doc":"Read `sync_transaction/1` document.","ref":"MnesiaAssistant.Transaction.html#sync_transaction/3"},{"type":"function","title":"MnesiaAssistant.Transaction.transaction/1","doc":"In contrast to the `sync_transaction/1` function, it guarantees that the transaction is not only committed locally,\nbut that the modifications are also successfully replicated to all of the other nodes before the function returns.\nWhen using this synchronous replication strategy, it waits for confirmation from all of the nodes, which guarantees that all replicas are consistent as soon as the transaction is finished.","ref":"MnesiaAssistant.Transaction.html#transaction/1"},{"type":"function","title":"Erlang document - MnesiaAssistant.Transaction.transaction/1","doc":"Executes the functional object Fun with arguments `Args` as a transaction.\n\nThe code that executes inside the transaction can consist of a series of table manipulation functions.\nIf something goes wrong inside the transaction as a result of a user error or a certain\ntable not being available, the entire transaction is terminated and the function `transaction/1` returns the tuple `{aborted, Reason}`.\n\nIf all is going well, {atomic, ResultOfFun} is returned, where ResultOfFun is the value\nof the last expression in Fun.\n\nA function that adds a family to the database can be written as follows if there is a structure `{family, Father, Mother, ChildrenList}`:\n\n```erlang\nadd_family({family, F, M, Children}) ->\n    ChildOids = lists:map(fun oid/1, Children),\n    Trans = fun() ->\n        mnesia:write(F#person{children = ChildOids}),\n        mnesia:write(M#person{children = ChildOids}),\n        Write = fun(Child) -> mnesia:write(Child) end,\n        lists:foreach(Write, Children)\n    end,\n    mnesia:transaction(Trans).\n\noid(Rec) -> {element(1, Rec), element(2, Rec)}.\n```\nThis code adds a set of people to the database. Running this code within one transaction ensures\nthat either the whole family is added to the database, or the whole transaction terminates.\nFor example, if the last child is badly formatted, or the executing process terminates\nbecause of an `'EXIT'` signal while executing the family code, the transaction terminates.\nThus, the situation where half a family is added can never occur.\n\nIt is also useful to update the database within a transaction if several processes concurrently\nupdate the same records. For example, the function raise(Name, Amount), which adds Amount\nto the salary field of a person, is to be implemented as follows:\n\n```erlang\nraise(Name, Amount) ->\n    mnesia:transaction(fun() ->\n        case mnesia:wread({person, Name}) of\n            [P] ->\n                Salary = Amount + P#person.salary,\n                P2 = P#person{salary = Salary},\n                mnesia:write(P2);\n            _ ->\n                mnesia:abort(\"No such person\")\n        end\n    end).\n```\n\nWhen this function executes within a transaction, several processes running on different nodes\ncan concurrently execute the function `raise/2` without interfering with each other.\n\n\nSince Mnesia detects deadlocks, a transaction can be restarted any number of times and\ntherefore the `Fun` shall not have any side effects such as waiting for specific messages.\nThis function attempts a restart as many times as specified in Retries.\nRetries must be an integer greater than `0` or the atom infinity, default is infinity.\nMnesia uses exit exceptions to signal that a transaction needs to be restarted, thus a Fun must not catch exit exceptions with reason `{aborted, term()}`.\n\n- `transaction(Fun)`\n- `transaction(Fun, Retries)`\n- `transaction(Fun, Args :: [Arg :: term()])`\n- `transaction(Fun, Args :: [Arg :: term()], Retries)`","ref":"MnesiaAssistant.Transaction.html#transaction/1-erlang-document"},{"type":"function","title":"Example: - MnesiaAssistant.Transaction.transaction/1","doc":"```elixir\n  trans = fn ->\n    MnesiaAssistant.Query.write({Person, 10, \"mishka\"})\n    MnesiaAssistant.Query.write({Person, 11, \"life\"})\n  end\n\n  MnesiaAssistant.Transaction.transaction(trans)\n```","ref":"MnesiaAssistant.Transaction.html#transaction/1-example"},{"type":"function","title":"MnesiaAssistant.Transaction.transaction/2","doc":"Read `transaction/1` document.","ref":"MnesiaAssistant.Transaction.html#transaction/2"},{"type":"function","title":"MnesiaAssistant.Transaction.transaction/3","doc":"Read `transaction/1` document.","ref":"MnesiaAssistant.Transaction.html#transaction/3"},{"type":"function","title":"MnesiaAssistant.Transaction.transaction_error/5","doc":"","ref":"MnesiaAssistant.Transaction.html#transaction_error/5"},{"type":"module","title":"PermissionAccess","doc":"Consider the scenario in which you are responsible for maintaining each user's access\n  level in the database related to users. In addition, each router in your controller needs\n  to be free for one access while preventing other things from accessing it. To achieve\n  this goal, the PermissionAccess module provides assistance in implementing a Unix-like mode\n  in the most straightforward manner feasible.\n  This module was written with the contribution of Mr. Toomaj Boloorian,\n  who can be found at the following GitHub address: https://github.com/toomaj\n  and and Shahryar Tavakkoli: https://github.com/shahryarjb","ref":"PermissionAccess.html"},{"type":"function","title":"PermissionAccess.is_permitted?/1","doc":"This section is identical to the function known as `permittes?/2`, with the exception that\n it examines only a single user access rather than a list of accesses.\n\n ```elixir\nPermissionAccess.is_permitted?(action: \"*\", @admin_router[\"AdminBlogNotifsLive\"])\n ```","ref":"PermissionAccess.html#is_permitted?/1"},{"type":"function","title":"PermissionAccess.permittes?/2","doc":"","ref":"PermissionAccess.html#permittes?/2"},{"type":"function","title":"Allow access to the user - PermissionAccess.permittes?/2","doc":"Access in this section is referred to as an action, and in addition, there are two sections included.\n\nThe first portion may grant access to an entire department or to an entire role, whereas the second part\nmay be delegated to a specific part. But this explanation is subject to alter depending on the strategy\nyou choose. Because of this, pay close attention to the instances that follow.\n\nWithin this section, the user has access to all portions of your program thanks to the wildcard permissions that have been granted to him.\n\n**Note**: You have the option of assigning a star `*` rating or writing it as `*:*`.\n\n```elixir\n@admin_router %{\n  # admin router\n  \"AdminDashboardLive\" => \"admin:*\",\n  \"AdminBlogPostsLive\" => \"admin:edit\",\n  \"AdminBlogPostLive\" => \"admin:edit\",\n  \"AdminBlogCategoriesLive\" => \"admin:edit\",\n  \"AdminBlogCategoryLive\" => \"admin:edit\",\n  \"AdminBookmarksLive\" => \"*\",\n  \"AdminSubscriptionsLive\" => \"*\",\n  \"AdminSubscriptionLive\" => \"*\",\n  \"AdminCommentsLive\" => \"admin:edit\",\n  \"AdminCommentLive\" => \"admin:edit\",\n  \"AdminUsersLive\" => \"*\",\n  \"AdminUserLive\" => \"*\",\n  \"AdminLogsLive\" => \"*\",\n  \"AdminSeoLive\" => \"*\",\n  \"AdminBlogPostAuthorsLive\" => \"admin:edit\",\n  \"AdminBlogNotifLive\" => \"*\",\n  \"AdminBlogNotifsLive\" => \"admin:view\"\n}\n\nuser_actions = [%{value: \"*\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[item])\n# This should be true, and the user has access.\n\nuser_actions = [%{value: \"*:edit\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[\"AdminBlogNotifsLive\"])\n# This should be false, and the user has no access.\n\nuser_actions = [%{value: \"*:edit\"}, %{value: \"admin:view\"}]\nPermissionAccess.permittes?(user_actions, @admin_router[\"AdminBlogNotifsLive\"])\n# This should be true, and the user has access.\n```","ref":"PermissionAccess.html#permittes?/2-allow-access-to-the-user"},{"type":"type","title":"PermissionAccess.action/0","doc":"","ref":"PermissionAccess.html#t:action/0"},{"type":"type","title":"PermissionAccess.user_permissions/0","doc":"","ref":"PermissionAccess.html#t:user_permissions/0"},{"type":"module","title":"QueueAssistant","doc":"This is a simple wrapper for the Erlang queue, in which the order of some entries\nhas also been changed\n\n- **Based on:** https://www.erlang.org/doc/man/queue","ref":"QueueAssistant.html"},{"type":"function","title":"QueueAssistant.all?/2","doc":"Returns true if all elements in enumerable are truthy. It is like `Enum.all?/1`.","ref":"QueueAssistant.html#all?/2"},{"type":"function","title":"Example: - QueueAssistant.all?/2","doc":"```elixir\nnew()\n|> insert(1)\n|> all?(fn x -> x >= 1 end)\n```","ref":"QueueAssistant.html#all?/2-example"},{"type":"function","title":"QueueAssistant.any?/2","doc":"Returns true if at least one element in enumerable is truthy.","ref":"QueueAssistant.html#any?/2"},{"type":"function","title":"Example: - QueueAssistant.any?/2","doc":"```elixir\nnew()\n|> insert(1)\n|> insert(2)\n|> any?(fn x -> x >= 2 end)\n```","ref":"QueueAssistant.html#any?/2-example"},{"type":"function","title":"QueueAssistant.cons/2","doc":"Inserts Item at the head of queue `q1`. Returns the new queue `q2`.","ref":"QueueAssistant.html#cons/2"},{"type":"function","title":"Example: - QueueAssistant.cons/2","doc":"```elixir\nqueue = cons(from_list([1, 2, 3]), 0)\nto_list queue\n# [0, 1, 2, 3]\n```","ref":"QueueAssistant.html#cons/2-example"},{"type":"function","title":"QueueAssistant.count/1","doc":"For see more information, check `len/1`","ref":"QueueAssistant.html#count/1"},{"type":"function","title":"QueueAssistant.daeh/1","doc":"Returns the tail item of a queue.","ref":"QueueAssistant.html#daeh/1"},{"type":"function","title":"Example: - QueueAssistant.daeh/1","doc":"```elixir\nqueue = daeh(from_list([1, 2, 3]))\n# 3\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before tailing it.","ref":"QueueAssistant.html#daeh/1-example"},{"type":"function","title":"Error output: - QueueAssistant.daeh/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:207: :queue.get_r({[], []})\n    iex:67: (file)\n```","ref":"QueueAssistant.html#daeh/1-error-output"},{"type":"function","title":"QueueAssistant.delete/2","doc":"Returns a copy of `q1` where the first item matching `item` is deleted, if there is such an item.","ref":"QueueAssistant.html#delete/2"},{"type":"function","title":"Example: - QueueAssistant.delete/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = queue |> delete(3)\nmember(queue1, 3)\n# false\n```","ref":"QueueAssistant.html#delete/2-example"},{"type":"function","title":"QueueAssistant.delete_r/2","doc":"Returns a copy of `q1` where the last item matching `item` is deleted, if there is such an item.","ref":"QueueAssistant.html#delete_r/2"},{"type":"function","title":"Example: - QueueAssistant.delete_r/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 3, 5])\nqueue1 = delete_r(queue, 3)\nto_list(queue1).\n[1,2,3,4,5]\n```","ref":"QueueAssistant.html#delete_r/2-example"},{"type":"function","title":"QueueAssistant.delete_with/2","doc":"Returns a copy of `q1` where the first item for which `fn` returns true is deleted,\nif there is such an item.","ref":"QueueAssistant.html#delete_with/2"},{"type":"function","title":"Example: - QueueAssistant.delete_with/2","doc":"```elixir\nqueue = from_list([100,1, 2, 3, 4, 5])\nqueue1 = delete_with(queue, fn x -> x > 0)\nto_list(queue1)\n[1,2,3,4,5]\n```\n\nIf we make it abstract in Elixir, you can do it with a list like this:\n\n```elixir\nlist = [1, 2, 3, 4, 5]\n{before, [h | t]} = Enum.split_with(list, fn x -> x < 4 end)\nnew_list = before ++ t\n```","ref":"QueueAssistant.html#delete_with/2-example"},{"type":"function","title":"QueueAssistant.delete_with_r/2","doc":"Returns a copy of `q1` where the last item for which `fn` returns true is deleted,\nif there is such an item.","ref":"QueueAssistant.html#delete_with_r/2"},{"type":"function","title":"Example: - QueueAssistant.delete_with_r/2","doc":"```elixir\nqueue = from_list([100,1, 4, 2, 3, 4, 5])\nqueue1 = delete_with_r(queue, fn x -> x == 4)\nto_list(queue1)\n[100,1, 4, 2, 3, 5]\n```","ref":"QueueAssistant.html#delete_with_r/2-example"},{"type":"function","title":"QueueAssistant.drop/1","doc":"Returns a queue `q2` that is the result of removing the front item from `q1`.","ref":"QueueAssistant.html#drop/1"},{"type":"function","title":"Example: - QueueAssistant.drop/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = drop(queue)\nto_list(queue1)\n# [2,3,4,5]\n```\n\n> **Fails with reason empty if `q1` is empty.** You must check if it is empty before dropping it.","ref":"QueueAssistant.html#drop/1-example"},{"type":"function","title":"Error output: - QueueAssistant.drop/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:252: :queue.drop({[], []})\n    iex:55: (file)\n```","ref":"QueueAssistant.html#drop/1-error-output"},{"type":"function","title":"QueueAssistant.drop_r/1","doc":"Returns a queue `q2` that is the result of removing the rear item from `q1`.","ref":"QueueAssistant.html#drop_r/1"},{"type":"function","title":"Example: - QueueAssistant.drop_r/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = drop_r(queue)\nto_list(queue1)\n# [1, 2, 3, 4]\n```\n\n> **Fails with reason empty if `q1` is empty.** You must check if it is empty before dropping it.","ref":"QueueAssistant.html#drop_r/1-example"},{"type":"function","title":"Error output: - QueueAssistant.drop_r/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:270: :queue.drop_r({[], []})\n    iex:58: (file)\n```","ref":"QueueAssistant.html#drop_r/1-error-output"},{"type":"function","title":"QueueAssistant.empty?/1","doc":"For see more information, check `is_empty?/1`","ref":"QueueAssistant.html#empty?/1"},{"type":"function","title":"QueueAssistant.filter/2","doc":"Filters the enumerable, i.e. returns only those elements for which fun returns a truthy value.\nIt is like `Enum.filter/2`.","ref":"QueueAssistant.html#filter/2"},{"type":"function","title":"Example: - QueueAssistant.filter/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = filter(queue, fn x -> x > 2 end)\nto_list(queue1)\n# [3, 4, 5]\n```","ref":"QueueAssistant.html#filter/2-example"},{"type":"function","title":"From Erlang docs: - QueueAssistant.filter/2","doc":"> So, `Fun(Item)` returning `[Item]` is thereby semantically equivalent to returning true,\n> just as returning `[]` is semantically equivalent to returning false.\n>\n> But returning a list builds more garbage than returning an atom.","ref":"QueueAssistant.html#filter/2-from-erlang-docs"},{"type":"function","title":"Example: - QueueAssistant.filter/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n# {[5, 4, 3], [1, 2]}\n\nqueue1 = filter(queue, fn x -> [x, x+1] end)\n# {[6, 5, 5, 4, 4, 3], [1, 2, 2, 3]}\n\nto_list(queue1)\n# [1, 2, 2, 3, 3, 4, 4, 5, 5, 6]\n```","ref":"QueueAssistant.html#filter/2-example"},{"type":"function","title":"QueueAssistant.filtermap/2","doc":"","ref":"QueueAssistant.html#filtermap/2"},{"type":"function","title":"From Erlang doc: - QueueAssistant.filtermap/2","doc":"Returns a queue `q2` that is the result of calling `Fun(Item)` on all items in `q1`.\n\nIf `Fun(Item)` returns true, Item is copied to the result queue. If it returns **false**,\nItem is not copied.\n\nIf it returns `{true, NewItem}`, the queue element at this position is replaced with `NewItem`\nin the result queue.","ref":"QueueAssistant.html#filtermap/2-from-erlang-doc"},{"type":"function","title":"Example: - QueueAssistant.filtermap/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = filtermap(queue, fn x -> x > 2 end)\nto_list(queue1)\n# [3, 4, 5]\n```","ref":"QueueAssistant.html#filtermap/2-example"},{"type":"function","title":"QueueAssistant.first/1","doc":"Please see `head/1`.","ref":"QueueAssistant.html#first/1"},{"type":"function","title":"QueueAssistant.fold/3","doc":"Invokes fun for each element in the enumerable with the accumulator. It is like `Enum.reduce/3`.","ref":"QueueAssistant.html#fold/3"},{"type":"function","title":"From Erlang docs: - QueueAssistant.fold/3","doc":"Calls Fun(Item, AccIn) on successive items Item of Queue, starting with `AccIn == Acc`0.\nThe queue is traversed in queue order, that is, from front to rear.\n\n`Fun/2` must return a new accumulator, which is passed to the next call.\nThe function returns the final value of the accumulator. `Acc0` is returned if the queue is empty.","ref":"QueueAssistant.html#fold/3-from-erlang-docs"},{"type":"function","title":"Example: - QueueAssistant.fold/3","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n\n1> fold(queue, 0, fn item, acc -> item + acc end)\n# 15\n\n2> fold(queue, 0, fn item, acc -> item * acc end)\n# 120\n```","ref":"QueueAssistant.html#fold/3-example"},{"type":"function","title":"QueueAssistant.from_list/1","doc":"Returns a queue containing the items in the same order; the head item of\nthe list becomes the front item of the queue.","ref":"QueueAssistant.html#from_list/1"},{"type":"function","title":"Example: - QueueAssistant.from_list/1","doc":"```elixir\nfrom_list([1, 2, 3, 4, 5])\n# {[5, 4, 3], [1, 2]}\n```","ref":"QueueAssistant.html#from_list/1-example"},{"type":"function","title":"QueueAssistant.get/1","doc":"Returns Item at the front of a queue.","ref":"QueueAssistant.html#get/1"},{"type":"function","title":"Example: - QueueAssistant.get/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n1 == get(queue)\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before getting it.","ref":"QueueAssistant.html#get/1-example"},{"type":"function","title":"Error output: - QueueAssistant.get/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:188: :queue.get({[], []})\n    iex:58: (file)\n```","ref":"QueueAssistant.html#get/1-error-output"},{"type":"function","title":"QueueAssistant.get_r/1","doc":"Returns Item at the rear of a queue.","ref":"QueueAssistant.html#get_r/1"},{"type":"function","title":"Example: - QueueAssistant.get_r/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n5 == get_r(queue)\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before getting it.","ref":"QueueAssistant.html#get_r/1-example"},{"type":"function","title":"Error output: - QueueAssistant.get_r/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:207: :queue.get_r({[], []})\n    iex:58: (file)\n```","ref":"QueueAssistant.html#get_r/1-error-output"},{"type":"function","title":"QueueAssistant.head/1","doc":"Returns the head item of a queue.","ref":"QueueAssistant.html#head/1"},{"type":"function","title":"Example: - QueueAssistant.head/1","doc":"```elixir\nqueue = head(from_list([1, 2, 3]))\n# 1\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before heading it.","ref":"QueueAssistant.html#head/1-example"},{"type":"function","title":"Error output: - QueueAssistant.head/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:662: :queue.head({[], []})\n    iex:67: (file)\n```","ref":"QueueAssistant.html#head/1-error-output"},{"type":"function","title":"QueueAssistant.in_r/2","doc":"For see more information, check `insert_r/2`","ref":"QueueAssistant.html#in_r/2"},{"type":"function","title":"QueueAssistant.init/1","doc":"Returns a queue `q2` that is the result of removing the tail item from `q1`.","ref":"QueueAssistant.html#init/1"},{"type":"function","title":"Example: - QueueAssistant.init/1","doc":"```elixir\ninit(from_list([1, 2, 3]))\n# {[2],[1]}\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before initing it.","ref":"QueueAssistant.html#init/1-example"},{"type":"function","title":"Error output: - QueueAssistant.init/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:270: :queue.drop_r({[], []})\n    iex:67: (file)\n```","ref":"QueueAssistant.html#init/1-error-output"},{"type":"function","title":"QueueAssistant.insert/2","doc":"Inserts Item at the rear of queue `q1`. Returns the resulting queue `q2`.","ref":"QueueAssistant.html#insert/2"},{"type":"function","title":"Example: - QueueAssistant.insert/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = insert(queue, 100)\nto_list(queue1)\n# [1, 2, 3, 4, 5, 100]\n```","ref":"QueueAssistant.html#insert/2-example"},{"type":"function","title":"QueueAssistant.insert_r/2","doc":"Inserts Item at the front of queue `q1`. Returns the resulting queue `q2`.","ref":"QueueAssistant.html#insert_r/2"},{"type":"function","title":"Example: - QueueAssistant.insert_r/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nqueue1 = insert_r(queue, 100)\nto_list(queue1)\n# [100, 1, 2, 3, 4, 5]\n```","ref":"QueueAssistant.html#insert_r/2-example"},{"type":"function","title":"QueueAssistant.is_empty?/1","doc":"Tests if a queue is empty and returns true if so, otherwise false.","ref":"QueueAssistant.html#is_empty?/1"},{"type":"function","title":"Example: - QueueAssistant.is_empty?/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nis_empty?(queue)\n# false\n```","ref":"QueueAssistant.html#is_empty?/1-example"},{"type":"function","title":"QueueAssistant.is_queue?/1","doc":"Tests if an entry is queue and returns true if so, otherwise false.","ref":"QueueAssistant.html#is_queue?/1"},{"type":"function","title":"Example: - QueueAssistant.is_queue?/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nis_queue?(queue)\n# true\n```","ref":"QueueAssistant.html#is_queue?/1-example"},{"type":"function","title":"QueueAssistant.join/2","doc":"Returns a queue `q3` that is the result of joining `q1` and `q2` with `q1` in front of `q2`.","ref":"QueueAssistant.html#join/2"},{"type":"function","title":"Example: - QueueAssistant.join/2","doc":"```elixir\nqueue = from_list([1, 2])\nqueue1 = from_list([3, 4])\njoin(queue, queue1)\n# [1, 2, 3, 4]\n```","ref":"QueueAssistant.html#join/2-example"},{"type":"function","title":"QueueAssistant.join_to_list/2","doc":"Please see `join/2` and `to_list/1`.","ref":"QueueAssistant.html#join_to_list/2"},{"type":"function","title":"QueueAssistant.last/1","doc":"Returns the tail item of a queue.","ref":"QueueAssistant.html#last/1"},{"type":"function","title":"Example: - QueueAssistant.last/1","doc":"```elixir\nlast(from_list([1,2 , 3]))\n# 3\n```\n\n> **Fails with reason empty if `queue` is empty.** You must check if it is empty before getting it.","ref":"QueueAssistant.html#last/1-example"},{"type":"function","title":"Error output: - QueueAssistant.last/1","doc":"```\n** (ErlangError) Erlang error: :empty\n    (stdlib 5.2.1) queue.erl:207: :queue.get_r({[], []})\n    iex:67: (file)\n```","ref":"QueueAssistant.html#last/1-error-output"},{"type":"function","title":"QueueAssistant.len/1","doc":"Calculates and returns the length of a queue.","ref":"QueueAssistant.html#len/1"},{"type":"function","title":"Example: - QueueAssistant.len/1","doc":"```elixir\nqueue = from_list([1, 2])\nlen(queue)\n# 2\n```","ref":"QueueAssistant.html#len/1-example"},{"type":"function","title":"QueueAssistant.liat/1","doc":"It is like `init/1`.","ref":"QueueAssistant.html#liat/1"},{"type":"function","title":"QueueAssistant.list_to_join/2","doc":"Please see `join/2` and `to_list/1`.","ref":"QueueAssistant.html#list_to_join/2"},{"type":"function","title":"QueueAssistant.member?/2","doc":"Checks if element exists within the queue.","ref":"QueueAssistant.html#member?/2"},{"type":"function","title":"Example: - QueueAssistant.member?/2","doc":"```elixir\nqueue = from_list([1, 2])\nmember?(queue, 2)\n# true\n```","ref":"QueueAssistant.html#member?/2-example"},{"type":"function","title":"QueueAssistant.new/0","doc":"Returns an empty queue.","ref":"QueueAssistant.html#new/0"},{"type":"function","title":"Example: - QueueAssistant.new/0","doc":"```elixir\nnew()\n# {[], []}\n```","ref":"QueueAssistant.html#new/0-example"},{"type":"function","title":"QueueAssistant.out/1","doc":"Removes the item at the front of queue `q1`. Returns tuple `{{:value, item}, q2}`,\nwhere Item is the item removed and `q2` is the resulting queue.\nIf `q1` is empty, tuple `{empty, q1}` is returned.","ref":"QueueAssistant.html#out/1"},{"type":"function","title":"Example: - QueueAssistant.out/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n# {[5, 4, 3],[1, 2]}\n\n{{:value, 1}, new_queue} = out(queue)\n# {{:value, 1}, {[5, 4, 3], [2]}}\n\nto_list(new_queue)\n# [2, 3, 4, 5]\n```","ref":"QueueAssistant.html#out/1-example"},{"type":"function","title":"QueueAssistant.out_r/1","doc":"Removes the item at the rear of queue `q1`. Returns tuple `{{:value, item}, q2}`,\nwhere Item is the item removed and `q2` is the resulting queue.\nIf `q1` is empty, tuple `{empty, q1}` is returned.","ref":"QueueAssistant.html#out_r/1"},{"type":"function","title":"Example: - QueueAssistant.out_r/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n# {[5,4,3], [1, 2]}\n\n{{:value, 5}, new_queue} = out_r(queue)\n# {{:value, 5}, {[5, 4, 3], [2, 1]}}\n\nto_list(new_queue)\n# [1, 2, 3, 4]\n```","ref":"QueueAssistant.html#out_r/1-example"},{"type":"function","title":"QueueAssistant.peek/1","doc":"Returns tuple `{:value, item}`, where Item is the front item of a queue,\nor empty if a queue is `:empty`.","ref":"QueueAssistant.html#peek/1"},{"type":"function","title":"Example: - QueueAssistant.peek/1","doc":"```elixir\npeek(new())\n# :empty\n\nqueue = from_list([1, 2 ,3 ,4 ,5])\n# {[5, 4, 3], [1, 2]}\n\npeek(queue)\n# {:value, 1}\n```","ref":"QueueAssistant.html#peek/1-example"},{"type":"function","title":"QueueAssistant.peek_r/1","doc":"Returns tuple `{:value, item}`, where Item is the rear item of a queue,\nor empty if a queue is `:empty`.","ref":"QueueAssistant.html#peek_r/1"},{"type":"function","title":"Example: - QueueAssistant.peek_r/1","doc":"```elixir\npeek_r(new())\n# :empty\n\nqueue = from_list([1, 2 ,3 ,4 ,5])\n# {[5, 4, 3], [1, 2]}\n\npeek_r(queue)\n# {:value, 5}\n```","ref":"QueueAssistant.html#peek_r/1-example"},{"type":"function","title":"QueueAssistant.queue?/1","doc":"For see more information, check `is_queue?/1`","ref":"QueueAssistant.html#queue?/1"},{"type":"function","title":"QueueAssistant.reduce/3","doc":"For see more information, check `fold/3`","ref":"QueueAssistant.html#reduce/3"},{"type":"function","title":"QueueAssistant.reverse/1","doc":"Returns a queue `q2` containing the items of `q1` in the reverse order.","ref":"QueueAssistant.html#reverse/1"},{"type":"function","title":"Example: - QueueAssistant.reverse/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nreverse(queue)\n# {[1, 2], [5, 4, 3]}\n```","ref":"QueueAssistant.html#reverse/1-example"},{"type":"function","title":"QueueAssistant.snoc/2","doc":"Inserts Item as the tail item of a queue `q1`. Returns a new queue like `q2`.","ref":"QueueAssistant.html#snoc/2"},{"type":"function","title":"Example: - QueueAssistant.snoc/2","doc":"```elixir\nqueue = snoc(from_list([1, 2, 3]), 4)\n# {[4, 3, 2], [1]}\n\nto_list(queue)\n# [1,2,3,4]\n```","ref":"QueueAssistant.html#snoc/2-example"},{"type":"function","title":"QueueAssistant.split/2","doc":"Splits `q1` in two. The `n` front items are put in `q2` and the rest in `q3`.","ref":"QueueAssistant.html#split/2"},{"type":"function","title":"Example: - QueueAssistant.split/2","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\nsplit(queue, 2)\n# {{[2], [1]}, {[5], [3, 4]}}\n```","ref":"QueueAssistant.html#split/2-example"},{"type":"function","title":"QueueAssistant.tail/1","doc":"Returns a queue `q2` that is the result of removing the head item from `q1`.\n\n  > **Fails with reason empty if `queue` is empty.** You must check if it is empty before tailing it.","ref":"QueueAssistant.html#tail/1"},{"type":"function","title":"Error output: - QueueAssistant.tail/1","doc":"```\n  ** (ErlangError) Erlang error: :empty\n      (stdlib 5.2.1) queue.erl:252: :queue.drop({[], []})\n      iex:67: (file)\n  ```","ref":"QueueAssistant.html#tail/1-error-output"},{"type":"function","title":"QueueAssistant.to_list/1","doc":"Returns a list of the items in the queue in the same order; the front item of\nthe queue becomes the head of the list.","ref":"QueueAssistant.html#to_list/1"},{"type":"function","title":"Example: - QueueAssistant.to_list/1","doc":"```elixir\nqueue = from_list([1, 2, 3, 4, 5])\n# {[5, 4, 3], [1, 2]}\n\nto_list(queue)\n# [1, 2, 3, 4, 5]\n```","ref":"QueueAssistant.html#to_list/1-example"},{"type":"type","title":"QueueAssistant.queue_type/0","doc":"","ref":"QueueAssistant.html#t:queue_type/0"},{"type":"exception","title":"MishkaDeveloperTools.Helper.UUID.HelperEcto.CastError","doc":"Raised when a changeset can't cast a value.","ref":"MishkaDeveloperTools.Helper.UUID.HelperEcto.CastError.html"},{"type":"function","title":"MishkaDeveloperTools.Helper.UUID.HelperEcto.CastError.format/1","doc":"Format type for error messaging and logs.","ref":"MishkaDeveloperTools.Helper.UUID.HelperEcto.CastError.html#format/1"},{"type":"extras","title":"Mishka Elixir Developer Tools","doc":"# Mishka Elixir Developer Tools\n\nWe tried to deliver a series of our client's [**CMS**](https://github.com/mishka-group/mishka-cms) built on [**Elixir**](https://elixir-lang.org/) at the start of the [**Mishka Group**](https://github.com/mishka-group) project, but we recently archived this open-source project and have yet to make plans to rework and expand it. This system was created using [**Phoenix**](https://www.phoenixframework.org/) and [**Phoenix LiveView**](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html). After a long period, a series of macros and functional modules emerged from this project and our other projects, which we are gradually publishing in this library.\n\n> **NOTICE**: Do not use the master branch; this library is under heavy development. Expect version `0.1.7`, and for using the new features, please wait until a new release is out.\n\n---\n\n- ### [GuardedStruct](https://github.com/mishka-group/guarded_struct)\n\n  **We recently separated the [GuardedStruct](https://github.com/mishka-group/guarded_struct) macro into a standalone library. Please visit its repository for more information.**\n\n  > The creation of this macro will allow you to build `Structs` that provide you with a number of important options, including the following:\n  >\n  > 1. Validation\n  > 2. Sanitizing\n  > 3. Constructor\n  > 4. It provides the capacity to operate in a nested style simultaneously.\n\n- ### [PermissionAccess](https://github.com/mishka-group/mishka_developer_tools/blob/master/guidance/permission-access.md)\n\n> Consider the scenario in which you are responsible for maintaining each user's access level in the database related to users.\n> **It is unix like way**.\n\n---\n\n> **Mishka developer tools** provides some macros and modules to make creating your elixir application as easy as possible","ref":"readme.html"},{"type":"extras","title":"Installation - Mishka Elixir Developer Tools","doc":"The package can be installed by adding `mishka_developer_tools` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mishka_developer_tools, \"~> 0.1.7\"}\n  ]\nend\n```\n\nThe docs can be found at [https://hexdocs.pm/mishka_developer_tools](https://hexdocs.pm/mishka_developer_tools).\n\n[![Run in Livebook](https://livebook.dev/badge/v1/pink.svg)](https://livebook.dev/run?url=https%3A%2F%2Fgithub.com%2Fmishka-group%2Fmishka_developer_tools%2Fblob%2Fmaster%2Fguidance%2Fguarded-struct.livemd)\n\n---\n\n# Donate\n\nIf the project was useful for you, the only way you can donate to me is the following ways\n\n| **BTC**                                                                                                                            | **ETH**                                                                                                                            | **DOGE**                                                                                                                           | **TRX**                                                                                                                            |\n| ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------- |\n|   |   |   |   |\n\n \n   Donate addresses \n\n**BTC**:‌\n\n```\nbc1q24pmrpn8v9dddgpg3vw9nld6hl9n5dkw5zkf2c\n```\n\n**ETH**:\n\n```\n0xD99feB9db83245dE8B9D23052aa8e62feedE764D\n```\n\n**DOGE**:\n\n```\nDGGT5PfoQsbz3H77sdJ1msfqzfV63Q3nyH\n```\n\n**TRX**:\n\n```\nTBamHas3wAxSEvtBcWKuT3zphckZo88puz\n```","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}